!$Id: 
!
!=======================================================================
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ FLEXPART @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!=====|==1=========2=========3=========4=========5=========6=========7==
!
! CHANGES TO THE ROUTINES BY A. STOHL
! XI,XI0,ETA,ETA0 ARE DOUBLE PRECISION VARIABLES TO AVOID PROBLEMS
! AT POLES

       SUBROUTINE CC2GLL (STRCMP, XLAT,XLONG, UE,VN, UG,VG)
!*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
       PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
       DOUBLE PRECISION XPOLG,YPOLG,ALONG,SLONG,CLONG,ROT
       REAL STRCMP(9)
       ALONG = CSPANF( XLONG - STRCMP(2), -180., 180.)
       IF (XLAT.GT.89.) THEN
!*  NORTH POLAR METEOROLOGICAL ORIENTATION: "NORTH" ALONG PRIME MERIDIAN
         ROT = - STRCMP(1) * ALONG + XLONG - 180.
       ELSEIF (XLAT.LT.-89.) THEN
!*  SOUTH POLAR METEOROLOGICAL ORIENTATION: "NORTH" ALONG PRIME MERIDIAN
         ROT = - STRCMP(1) * ALONG - XLONG
       ELSE
         ROT = - STRCMP(1) * ALONG
       ENDIF
       SLONG = SIN( RADPDG * ROT )
       CLONG = COS( RADPDG * ROT )
       XPOLG = SLONG * STRCMP(5) + CLONG * STRCMP(6)
       YPOLG = CLONG * STRCMP(5) - SLONG * STRCMP(6)
       UG = YPOLG * UE + XPOLG * VN
       VG = YPOLG * VN - XPOLG * UE
       RETURN        
       END

       SUBROUTINE CCRVLL (STRCMP, XLAT,XLONG, GX,GY)
!*  WRITTEN ON 9/20/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
       PARAMETER (REARTH=6371.2)
       PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
       DOUBLE PRECISION XPOLG,YPOLG,TEMP,ALONG,SLONG,CLONG,CTEMP
       REAL STRCMP(9)
       ALONG = CSPANF( XLONG - STRCMP(2), -180., 180.)
       SLONG = SIN( RADPDG * STRCMP(1) * ALONG)        
       CLONG = COS( RADPDG * STRCMP(1) * ALONG)
       XPOLG = - SLONG * STRCMP(5) + CLONG * STRCMP(6)
       YPOLG = CLONG * STRCMP(5) + SLONG * STRCMP(6)
       TEMP = SIN(RADPDG * XLAT)
       CTEMP = COS(RADPDG * XLAT)
       CURV = (STRCMP(1) - TEMP) / CTEMP / REARTH
       GX = CURV * XPOLG
       GY = CURV * YPOLG
       RETURN
       END

       SUBROUTINE CCRVXY (STRCMP, X,Y, GX,GY)
!*  WRITTEN ON 9/20/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
       PARAMETER (REARTH=6371.2)
       PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
       REAL STRCMP(9)
       DOUBLE PRECISION XPOLG,YPOLG,TEMP,YMERC,EFACT,CURV
       TEMP = STRCMP(1) * STRCMP(7) /REARTH
       XPOLG = STRCMP(6) + TEMP * (STRCMP(3) - X)
       YPOLG = STRCMP(5) + TEMP * (STRCMP(4) - Y)
       TEMP = SQRT ( XPOLG ** 2 + YPOLG ** 2 )
       IF (TEMP.GT.0.) THEN
         YMERC = - LOG( TEMP) /STRCMP(1)
         EFACT = EXP(YMERC) 
         CURV = ( (STRCMP(1) - 1.D0) * EFACT +  &
                  (STRCMP(1) + 1.D0) / EFACT )  &
                 * .5D0 / REARTH
         GX = XPOLG * CURV / TEMP
         GY = YPOLG * CURV / TEMP
       ELSE
         IF (ABS(STRCMP(1)) .EQ. 1.) THEN
           GX = 0.
           GY = 0.
         ELSE
           GX = 1./REARTH
           GY = 1./REARTH
         ENDIF
       ENDIF
       RETURN
       END

       SUBROUTINE CG2CLL (STRCMP, XLAT,XLONG, UG,VG, UE,VN)
!*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
       PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
       DOUBLE PRECISION XPOLG,YPOLG,ALONG,SLONG,CLONG,ROT
       REAL STRCMP(9)
       ALONG = CSPANF( XLONG - STRCMP(2), -180., 180.)
       IF (XLAT.GT.89.) THEN
!*  NORTH POLAR METEOROLOGICAL ORIENTATION: "NORTH" ALONG PRIME MERIDIAN
         ROT = - STRCMP(1) * ALONG + XLONG - 180.
       ELSEIF (XLAT.LT.-89.) THEN
!*  SOUTH POLAR METEOROLOGICAL ORIENTATION: "NORTH" ALONG PRIME MERIDIAN
         ROT = - STRCMP(1) * ALONG - XLONG
       ELSE
         ROT = - STRCMP(1) * ALONG
       ENDIF
       SLONG = SIN( RADPDG * ROT )
       CLONG = COS( RADPDG * ROT )
       XPOLG = SLONG * STRCMP(5) + CLONG * STRCMP(6)
       YPOLG = CLONG * STRCMP(5) - SLONG * STRCMP(6)
       UE = YPOLG * UG - XPOLG * VG
       VN = YPOLG * VG + XPOLG * UG
       RETURN
       END

       SUBROUTINE CG2CXY (STRCMP, X,Y, UG,VG, UE,VN)
!*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
       PARAMETER (REARTH=6371.2)
       REAL STRCMP(9)
       DOUBLE PRECISION XPOLG,YPOLG,TEMP,XI0,ETA0,XI,ETA
       PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
       XI0 = ( X - STRCMP(3) ) * STRCMP(7) / REARTH
       ETA0 = ( Y - STRCMP(4) ) * STRCMP(7) /REARTH
       XI = XI0 * STRCMP(5) - ETA0 * STRCMP(6)
       ETA = ETA0 * STRCMP(5) + XI0 * STRCMP(6)
       RADIAL = 2. * ETA - STRCMP(1) * (XI*XI + ETA*ETA)
       IF (RADIAL.GT.STRCMP(8)) THEN
!*  CASE NORTH OF 89 DEGREES.  METEOROLOGICAL WIND DIRECTION DEFINITION
!*      CHANGES.
         CALL CNXYLL(STRCMP, XI,ETA, XLAT,XLONG) 
!*  NORTH POLAR METEOROLOGICAL ORIENTATION: "NORTH" ALONG PRIME MERIDIAN
         ROT = STRCMP(1) * (XLONG - STRCMP(2)) - XLONG - 180.
         SLONG = - SIN( RADPDG * ROT )
         CLONG = COS( RADPDG * ROT )
         XPOLG = SLONG * STRCMP(5) + CLONG * STRCMP(6)
         YPOLG = CLONG * STRCMP(5) - SLONG * STRCMP(6)
       ELSE IF (RADIAL.LT.STRCMP(9)) THEN
!*  CASE SOUTH OF -89 DEGREES.  METEOROLOGICAL WIND DIRECTION DEFINITION
!*      CHANGES.
         CALL CNXYLL(STRCMP, XI,ETA, XLAT,XLONG) 
!*  SOUTH POLAR METEOROLOGICAL ORIENTATION: "NORTH" ALONG PRIME MERIDIAN
         ROT = STRCMP(1) * (XLONG - STRCMP(2)) + XLONG
         SLONG = - SIN( RADPDG * ROT )
         CLONG = COS( RADPDG * ROT )
         XPOLG = SLONG * STRCMP(5) + CLONG * STRCMP(6)
         YPOLG = CLONG * STRCMP(5) - SLONG * STRCMP(6)
       ELSE
!* NORMAL CASE.  METEOROLOGICAL DIRECTION OF WIND RELATED TO TRUE NORTH.
         XPOLG = STRCMP(6) - STRCMP(1) * XI0
         YPOLG = STRCMP(5) - STRCMP(1) * ETA0
         TEMP = SQRT ( XPOLG ** 2 + YPOLG ** 2 )
         XPOLG = XPOLG / TEMP
         YPOLG = YPOLG / TEMP
       END IF
       UE = ( YPOLG * UG - XPOLG * VG )
       VN = ( YPOLG * VG + XPOLG * UG )
       RETURN
       END

       REAL FUNCTION CGSZLL (STRCMP, XLAT,XLONG)
!*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
       PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180D0/PI)
       REAL STRCMP(9)
       DOUBLE PRECISION SLAT,YMERC,EFACT
       IF (XLAT .GT. 89.985) THEN
!* CLOSE TO NORTH POLE
         IF (STRCMP(1) .GT. 0.9999) THEN
!* AND TO GAMMA == 1.
           CGSZLL = 2. * STRCMP(7)
           RETURN
         ENDIF
         EFACT = COS(RADPDG * XLAT)
         IF (EFACT .LE. 0.) THEN
           CGSZLL = 0.
           RETURN
         ELSE
           YMERC = - LOG( EFACT /(1. + SIN(RADPDG * XLAT)))
         ENDIF
       ELSE IF (XLAT .LT. -89.985) THEN
!* CLOSE TO SOUTH POLE
         IF (STRCMP(1) .LT. -0.9999) THEN
!* AND TO GAMMA == -1.0
           CGSZLL = 2. * STRCMP(7)
           RETURN
         ENDIF
         EFACT = COS(RADPDG * XLAT)
         IF (EFACT .LE. 0.) THEN
           CGSZLL = 0.
           RETURN
         ELSE
           YMERC = LOG( EFACT /(1. - SIN(RADPDG * XLAT)))
         ENDIF
       ELSE
       SLAT = SIN(RADPDG * XLAT)
       YMERC = LOG((1. + SLAT) / (1. - SLAT))/2.
!       EFACT = EXP(YMERC)
!       CGSZLL = 2. * STRCMP(7) * EXP (STRCMP(1) * YMERC)
!     C        / (EFACT + 1./EFACT)
       ENDIF
       CGSZLL = STRCMP(7) * COS(RADPDG * XLAT) * EXP(STRCMP(1) *YMERC)
       RETURN
       END

       REAL FUNCTION CGSZXY (STRCMP, X,Y)
!*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
       PARAMETER (REARTH=6371.2,ALMST1=.9999999)
       REAL STRCMP(9)
       DOUBLE PRECISION YMERC,EFACT
       DOUBLE PRECISION XI0,ETA0,XI,ETA
       XI0 = ( X - STRCMP(3) ) * STRCMP(7) / REARTH
       ETA0 = ( Y - STRCMP(4) ) * STRCMP(7) /REARTH
       XI = XI0 * STRCMP(5) - ETA0 * STRCMP(6)
       ETA = ETA0 * STRCMP(5) + XI0 * STRCMP(6)
       RADIAL = 2. * ETA - STRCMP(1) * (XI*XI + ETA*ETA)
       EFACT = STRCMP(1) * RADIAL
       IF (EFACT .GT. ALMST1) THEN
         IF (STRCMP(1).GT.ALMST1) THEN
           CGSZXY = 2. * STRCMP(7)
         ELSE
           CGSZXY = 0.
         ENDIF
         RETURN
       ENDIF
       IF (ABS(EFACT) .LT. 1.E-2) THEN
         TEMP = (EFACT / (2. - EFACT) )**2
         YMERC = RADIAL / (2. - EFACT) * (1.    + TEMP * &
                                         (1./3. + TEMP * &
                                         (1./5. + TEMP * &
                                         (1./7. ))))
       ELSE
         YMERC = - LOG( 1. - EFACT ) /2. /STRCMP(1)
       ENDIF
       IF (YMERC .GT. 6.) THEN
         IF (STRCMP(1) .GT. ALMST1) THEN
           CGSZXY = 2. * STRCMP(7)
         ELSE
           CGSZXY = 0.
         ENDIF
       ELSE IF (YMERC .LT. -6.) THEN
         IF (STRCMP(1) .LT. -ALMST1) THEN
           CGSZXY = 2. * STRCMP(7)
         ELSE
           CGSZXY = 0.
         ENDIF
       ELSE
         EFACT = EXP(YMERC)
         CGSZXY = 2. * STRCMP(7) * EXP (STRCMP(1) * YMERC) &
                                 / (EFACT + 1./EFACT)
       ENDIF
       RETURN
       END

       SUBROUTINE CLL2XY (STRCMP, XLAT,XLONG, X,Y)
!*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
       PARAMETER (REARTH=6371.2)
       REAL STRCMP(9)
       CALL CNLLXY(STRCMP, XLAT,XLONG, XI,ETA)
       X = STRCMP(3) + REARTH/STRCMP(7) *                  &
             (XI * STRCMP(5) + ETA * STRCMP(6) )
       Y = STRCMP(4) + REARTH/STRCMP(7) *                  &
             (ETA * STRCMP(5) - XI * STRCMP(6) )
       RETURN
       END

       SUBROUTINE CNLLXY (STRCMP, XLAT,XLONG, XI,ETA)
!*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
!  MAIN TRANSFORMATION ROUTINE FROM LATITUDE-LONGITUDE TO
!  CANONICAL (EQUATOR-CENTERED, RADIAN UNIT) COORDINATES
       PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
       PARAMETER (ALMST1=.9999999)
       REAL STRCMP(9)
        DOUBLE PRECISION GAMMA
       DOUBLE PRECISION DLONG,DLAT,SLAT,MERCY,GMERCY
       GAMMA = STRCMP(1)
       DLAT = XLAT
       DLONG = CSPANF(XLONG - STRCMP(2), -180., 180.)
       DLONG = DLONG * RADPDG
       GDLONG = GAMMA * DLONG
       IF (ABS(GDLONG) .LT. .01) THEN
!  CODE FOR GAMMA SMALL OR ZERO.  THIS AVOIDS ROUND-OFF ERROR OR DIVIDE-
!  BY ZERO IN THE CASE OF MERCATOR OR NEAR-MERCATOR PROJECTIONS.
         GDLONG = GDLONG * GDLONG
         SNDGAM = DLONG * (1. - 1./6. * GDLONG *        &
                          (1. - 1./20. * GDLONG *       &
                          (1. - 1./42. * GDLONG )))
         CSDGAM = DLONG * DLONG * .5 *                  &
                          (1. - 1./12. * GDLONG *       &
                          (1. - 1./30. * GDLONG *       &
                          (1. - 1./56. * GDLONG )))
       ELSE
! CODE FOR MODERATE VALUES OF GAMMA
         SNDGAM = SIN (GDLONG) /GAMMA
         CSDGAM = (1. - COS(GDLONG) )/GAMMA /GAMMA
       ENDIF
       SLAT = SIN(RADPDG * DLAT)
       IF ((SLAT .GE. ALMST1) .OR. (SLAT .LE. -ALMST1)) THEN
         ETA = 1./STRCMP(1)
         XI = 0.
         RETURN
       ENDIF
       MERCY = .5 * LOG( (1. + SLAT) / (1. - SLAT) )
       GMERCY = GAMMA * MERCY
       IF (ABS(GMERCY) .LT. .001) THEN
!  CODE FOR GAMMA SMALL OR ZERO.  THIS AVOIDS ROUND-OFF ERROR OR DIVIDE-
!  BY ZERO IN THE CASE OF MERCATOR OR NEAR-MERCATOR PROJECTIONS.
         RHOG1 = MERCY * (1. - .5 * GMERCY *          &
                         (1. - 1./3. * GMERCY *       &
                         (1. - 1./4. * GMERCY ) ) )
       ELSE
! CODE FOR MODERATE VALUES OF GAMMA
         RHOG1 = (1. - EXP(-GMERCY)) / GAMMA
       ENDIF
       ETA = RHOG1 + (1. - GAMMA * RHOG1) * GAMMA * CSDGAM
       XI = (1. - GAMMA * RHOG1 ) * SNDGAM
       END

       SUBROUTINE CNXYLL (STRCMP, XI,ETA, XLAT,XLONG)
!*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
!  MAIN TRANSFORMATION ROUTINE FROM CANONICAL (EQUATOR-CENTERED,
!  RADIAN UNIT) COORDINATES
       PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
       PARAMETER (ALMST1=.9999999)
       REAL STRCMP(9)
       DOUBLE PRECISION GAMMA,TEMP,ARG1,ARG2,YMERC,ALONG,GXI,CGETA
        DOUBLE PRECISION XI,ETA
       GAMMA = STRCMP(1)
!  CALCULATE EQUIVALENT MERCATOR COORDINATE
       ODIST = XI*XI + ETA*ETA
       ARG2 = 2. * ETA - GAMMA * (XI*XI + ETA*ETA)
       ARG1 = GAMMA * ARG2
! Change by A. Stohl to avoid problems close to the poles
! IF (ARG1 .GE. ALMST1) THEN
!  DISTANCE TO NORTH (OR SOUTH) POLE IS ZERO (OR IMAGINARY ;) )
! XLAT = SIGN(90.,STRCMP(1))
! XLONG = STRCMP(2)
! RETURN
! ENDIF
       IF (ABS(ARG1) .LT. .01) THEN
!  CODE FOR GAMMA SMALL OR ZERO.  THIS AVOIDS ROUND-OFF ERROR OR DIVIDE-
!  BY ZERO IN THE CASE OF MERCATOR OR NEAR-MERCATOR PROJECTIONS.
         TEMP = (ARG1 / (2. - ARG1) )**2
         YMERC = ARG2 / (2. - ARG1) * (1.    + TEMP *   &
                                      (1./3. + TEMP *   &
                                      (1./5. + TEMP *   &
                                      (1./7. ))))
       ELSE
! CODE FOR MODERATE VALUES OF GAMMA
         YMERC = - LOG ( 1. - ARG1 ) /2. / GAMMA
       ENDIF
!  CONVERT YMERC TO LATITUDE
       TEMP = EXP( - ABS(YMERC) )
       XLAT = SIGN(ATAN2((1. - TEMP) * (1. + TEMP), 2. * TEMP), YMERC)
!  FIND LONGITUDES
       GXI = GAMMA*XI
       CGETA = 1. - GAMMA * ETA
       IF ( ABS(GXI) .LT. .01*CGETA ) THEN
!  CODE FOR GAMMA SMALL OR ZERO.  THIS AVOIDS ROUND-OFF ERROR OR DIVIDE-
!  BY ZERO IN THE CASE OF MERCATOR OR NEAR-MERCATOR PROJECTIONS.
         TEMP = ( GXI /CGETA )**2
         ALONG = XI / CGETA * (1.    - TEMP *     &
                              (1./3. - TEMP *     &
                              (1./5. - TEMP *     &
                              (1./7.   ))))
       ELSE
! CODE FOR MODERATE VALUES OF GAMMA
         ALONG = ATAN2( GXI, CGETA) / GAMMA
       ENDIF
       XLONG = SNGL(STRCMP(2) + DGPRAD * ALONG)
       XLAT = XLAT * DGPRAD
       RETURN
       END

       SUBROUTINE CPOLLL (STRCMP, XLAT,XLONG, ENX,ENY,ENZ)
!*  WRITTEN ON 11/23/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
       PARAMETER (PI=3.14159265358979,RADPDG=PI/180.,DGPRAD=180./PI)
       DOUBLE PRECISION XPOLG,YPOLG,ALONG,SLONG,CLONG,ROT
       REAL STRCMP(9)
       ALONG = CSPANF( XLONG - STRCMP(2), -180., 180.)
         ROT = - STRCMP(1) * ALONG
       SLONG = SIN( RADPDG * ROT )
       CLONG = COS( RADPDG * ROT )
       XPOLG = SLONG * STRCMP(5) + CLONG * STRCMP(6)
       YPOLG = CLONG * STRCMP(5) - SLONG * STRCMP(6)
       CLAT = COS(RADPDG * XLAT)
       ENX = CLAT * XPOLG
       ENY = CLAT * YPOLG
       ENZ = SIN(RADPDG * XLAT)
       RETURN
       END

       SUBROUTINE CPOLXY (STRCMP, X,Y, ENX,ENY,ENZ)
!*  WRITTEN ON 11/26/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
       PARAMETER (REARTH=6371.2)
       PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
       REAL STRCMP(9)
       DOUBLE PRECISION XPOL,YPOL,TEMP,XI0,ETA0,XI,ETA,RADIAL
       DOUBLE PRECISION TEMP2,YMERC,ARG,OARG,CLAT
       XI0 = ( X - STRCMP(3) ) * STRCMP(7) / REARTH
       ETA0 = ( Y - STRCMP(4) ) * STRCMP(7) /REARTH
       XI = XI0 * STRCMP(5) - ETA0 * STRCMP(6)
       ETA = ETA0 * STRCMP(5) + XI0 * STRCMP(6)
       RADIAL = 2. * ETA -  STRCMP(1) * (XI*XI + ETA*ETA)
       TEMP = STRCMP(1) * RADIAL
       IF (TEMP .GE. 1.) THEN
         ENX = 0.
         ENY = 0.
         ENZ = SIGN(1.,STRCMP(1))
         RETURN
       ENDIF
       IF (ABS(TEMP).LT.1.E-2) THEN
         TEMP2 = (TEMP / (2. - TEMP))**2
         YMERC = RADIAL / (2. - TEMP) * (1. + TEMP2 *      &
                                     (1./3. + TEMP2 *   &
                                     (1./5. + TEMP2 *   &
                                     (1./7.))))
       ELSE
         YMERC = -.5 * LOG(1. - TEMP) / STRCMP(1)
       ENDIF
       ARG = EXP( YMERC )
       OARG = 1./ARG
       CLAT = 2./(ARG + OARG)
       ENZ = (ARG - OARG) * CLAT /2.
       TEMP = CLAT / SQRT(1. - TEMP)
       XPOL = - XI * STRCMP(1) * TEMP
       YPOL = (1. - ETA * STRCMP(1) ) * TEMP
       ENX = XPOL * STRCMP(5) + YPOL * STRCMP(6)
       ENY = YPOL * STRCMP(5) - XPOL * STRCMP(6)
       RETURN
       END

       REAL FUNCTION CSPANF (VALUE, BEGIN, END)
!*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
!* REAL FUNCTION CSPANF RETURNS A VALUE IN THE INTERVAL (BEGIN,END]
!* WHICH IS EQUIVALENT TO VALUE, MOD (END - BEGIN).  IT IS USED TO
!* REDUCE PERIODIC VARIABLES TO A STANDARD RANGE.  IT ADJUSTS FOR THE
!* BEHAVIOR OF THE MOD FUNCTION WHICH PROVIDES POSITIVE RESULTS FOR
!* POSITIVE INPUT, AND NEGATIVE RESULTS FOR NEGATIVE INPUT
!* INPUT:
!*       VALUE - REAL NUMBER TO BE REDUCED TO THE SPAN
!*       BEGIN - FIRST VALUE OF THE SPAN
!*       END   - LAST VALUE OF THE SPAN
!* RETURNS:
!*       THE REDUCED VALUE
!* EXAMPLES:
!*      ALONG = CSPANF(XLONG, -180., +180.)
!*      DIR  = CSPANF(ANGLE, 0., 360.)
       REAL FIRST,LAST
       FIRST = MIN(BEGIN,END)
       LAST = MAX(BEGIN,END)
       VAL = MOD( VALUE - FIRST , LAST - FIRST)
       IF ( VAL .LE. 0.) THEN
         CSPANF = VAL + LAST
       ELSE
         CSPANF = VAL + FIRST
       ENDIF
       RETURN
       END

       SUBROUTINE CXY2LL (STRCMP, X,Y, XLAT,XLONG)
!*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
       PARAMETER (REARTH=6371.2)
        DOUBLE PRECISION XI0,ETA0,XI,ETA
       REAL STRCMP(9)
       XI0 = ( X - STRCMP(3) ) * STRCMP(7) / REARTH
       ETA0 = ( Y - STRCMP(4) ) * STRCMP(7) /REARTH
       XI = XI0 * STRCMP(5) - ETA0 * STRCMP(6)
       ETA = ETA0 * STRCMP(5) + XI0 * STRCMP(6)
       CALL CNXYLL(STRCMP, XI,ETA, XLAT,XLONG)
       XLONG = CSPANF(XLONG, -180., 180.)
       RETURN
       END

       REAL FUNCTION EQVLAT (XLAT1,XLAT2)
!*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
       PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
       SINL1 = SIN (XLAT1*RADPDG)
       SINL2 = SIN (XLAT2*RADPDG)
       IF (ABS(SINL1 - SINL2) .GT. .001) THEN
         AL1 = LOG((1. - SINL1)/(1. - SINL2))
         AL2 = LOG((1. + SINL1)/(1. + SINL2))
       ELSE
!  CASE LAT1 NEAR OR EQUAL TO LAT2
         TAU = - (SINL1 - SINL2)/(2. - SINL1 - SINL2)
         TAU = TAU*TAU
         AL1  = 2. / (2. - SINL1 - SINL2) * (1.    + TAU *   &
                                            (1./3. + TAU *   &
                                            (1./5. + TAU *   &
                                            (1./7.))))
         TAU =   (SINL1 - SINL2)/(2. + SINL1 + SINL2)
         TAU = TAU*TAU
         AL2  = -2. / (2. + SINL1 + SINL2) * (1.    + TAU *  &
                                             (1./3. + TAU *  &
                                             (1./5. + TAU *  &
                                             (1./7.))))
       ENDIF
       EQVLAT = ASIN((AL1 + AL2) / (AL1 - AL2))/RADPDG
       RETURN
       END

       SUBROUTINE STCM1P(STRCMP, X1,Y1, XLAT1,XLONG1,  &
                          XLATG,XLONGG, GRIDSZ, ORIENT)
!*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
       PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
       REAL STRCMP(9)
       DO K=3,4
         STRCMP (K) = 0.
       ENDDO
        TURN = RADPDG * (ORIENT - STRCMP(1) *      &
                  CSPANF(XLONGG - STRCMP(2), -180., 180.) )
       STRCMP (5) = COS (TURN)
       STRCMP (6) = - SIN (TURN)
       STRCMP (7) = 1.
       STRCMP (7) = GRIDSZ * STRCMP(7)            &
                   / CGSZLL(STRCMP, XLATG, STRCMP(2))
       CALL CLL2XY (STRCMP, XLAT1,XLONG1, X1A,Y1A)
       STRCMP(3) = STRCMP(3) + X1 - X1A
       STRCMP(4) = STRCMP(4) + Y1 - Y1A
       RETURN
       END

       SUBROUTINE STCM2P(STRCMP, X1,Y1, XLAT1,XLONG1, &
                                  X2,Y2, XLAT2,XLONG2)
!*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
       REAL STRCMP(9)
       DO K=3,6
         STRCMP (K) = 0.
       ENDDO
       STRCMP (5) = 1.
       STRCMP (7) = 1.
       CALL CLL2XY (STRCMP, XLAT1,XLONG1, X1A,Y1A)
       CALL CLL2XY (STRCMP, XLAT2,XLONG2, X2A,Y2A)
       DEN = SQRT( (X1 - X2)**2 + (Y1 - Y2)**2 )
       DENA = SQRT( (X1A - X2A)**2 + (Y1A - Y2A)**2 )
       STRCMP(5) = ((X1A - X2A)*(X1 - X2) + (Y1A - Y2A) * (Y1 - Y2)) &
          /DEN /DENA
       STRCMP(6) = ((Y1A - Y2A)*(X1 - X2) - (X1A - X2A) * (Y1 - Y2)) &
          /DEN /DENA
       STRCMP (7) = STRCMP(7) * DENA / DEN
       CALL CLL2XY (STRCMP, XLAT1,XLONG1, X1A,Y1A)
       STRCMP(3) = STRCMP(3) + X1 - X1A
       STRCMP(4) = STRCMP(4) + Y1 - Y1A
       RETURN
       END

!*  GENERAL CONFORMAL MAP ROUTINES FOR METEOROLOGICAL MODELERS
!*  WRITTEN ON 3/31/94 BY

!* Dr. Albion Taylor
!* NOAA / OAR / ARL                  Phone: (301) 713-0295 x 132
!* Rm. 3151, 1315 East-West Highway  Fax:   (301) 713-0119
!* Silver Spring, MD 20910           E-mail: ADTaylor@arlrisc.ssmc.noaa.gov 

!*  SUBROUTINE STLMBR (STRCMP, TNGLAT, CLONG)
!*    THIS ROUTINE INITIALIZES THE MAP STRUCTURE ARRAY STRCMP TO
!*    THE FORM OF A SPECIFIC MAP PROJECTION
!*  INPUTS:
!*    TNGLAT - THE LATITUDE AT WHICH THE PROJECTION WILL BE TANGENT
!*             TO THE EARTH.  +90. FOR NORTH POLAR STEREOGRAPHIC,
!*             -90. FOR SOUTH POLAR STEREOGRAPHIC, 0. FOR MERCATOR,
!*             AND OTHER VALUES FOR LAMBERT CONFORMAL. 
!*             -90 <= TNGLAT <= 90.
!*    CLONG -  A LONGITUDE IN THE REGION UNDER CONSIDERATION.  LONGITUDES
!*             BETWEEN CLONG-180. AND CLONG+180.  WILL BE MAPPED IN ONE
!*             CONNECTED REGION
!*  OUTPUTS:
!*    STRCMP - A 9-VALUE MAP STRUCTURE ARRAY FOR USE WITH SUBSEQUENT
!*             CALLS TO THE COORDINATE TRANSFORM ROUTINES.
!*
!*  REAL FUNCTION EQVLAT (XLAT1,XLAT2)
!*    THIS FUNCTION IS PROVIDED TO ASSIST IN FINDING THE TANGENT LATITUDE
!*    EQUIVALENT TO THE 2-REFERENCE LATITUDE SPECIFICATION IN THE LEGEND
!*    OF MOST LAMBERT CONFORMAL MAPS.  IF THE MAP SPECIFIES "SCALE 
!*    1:XXXXX TRUE AT 40N AND 60N", THEN EQVLAT(40.,60.) WILL RETURN THE
!*    EQUIVALENT TANGENT LATITUDE.
!*  INPUTS:
!*    XLAT1,XLAT2:  THE TWO LATITUDES SPECIFIED IN THE MAP LEGEND
!*  RETURNS:
!*    THE EQUIVALENT TANGENT LATITUDE
!*  EXAMPLE:  CALL STLMBR(STRCMP, EQVLAT(40.,60.), 90.)

!*  SUBROUTINE STCM2P (STRCMP, X1,Y1, XLAT1,XLONG1,
!*          X2,Y2, XLAT2,XLONG2)
!*  SUBROUTINE STCM1P (STRCMP, X1,Y1, XLAT1,XLONG1,
!*          XLATG,XLONGG, GRIDSZ, ORIENT)
!*    THESE ROUTINES COMPLETE THE SPECIFICATION OF THE MAP STRUCTURE
!*    ARRAY BY CONFORMING THE MAP COORDINATES TO THE SPECIFICATIONS
!*    OF A PARTICULAR GRID.  EITHER STCM1P OR STCM2P MUST BE CALLED,
!*    BUT NOT BOTH
!*  INPUTS:
!*    STRCMP - A 9-VALUE MAP STRUCTURE ARRAY, SET TO A PARTICULAR MAP
!*             FORM BY A PREVIOUS CALL TO STLMBR
!*    FOR STCM2P:
!*      X1,Y1, X2,Y2 - THE MAP COORDINATES OF TWO POINTS ON THE GRID
!*      XLAT1,XLONG1, XLAT2,XLONG2 - THE GEOGRAPHIC COORDINATES OF THE
!*             SAME TWO POINTS
!*    FOR STCM1P:
!*      X1,Y1 - THE MAP COORDINATES OF ONE POINT ON THE GRID
!*      XLAT1,XLONG1 - THE GEOGRAPHIC COORDINATES OF THE SAME POINT
!*      XLATG,XLONGG - LATITUDE AND LONGITUDE OF REFERENCE POINT FOR
!*             GRIDSZ AND ORIENTATION SPECIFICATION.
!*      GRIDSZ - THE DESIRED GRID SIZE IN KILOMETERS, AT XLATG,XLONGG
!*      ORIENT - THE ANGLE, WITH RESPECT TO NORTH, OF A Y-GRID LINE, AT
!*             THE POINT XLATG,XLONGG
!*  OUTPUTS:
!*    STRCMP - A 9-VALUE MAP STRUCTURE ARRAY, FULLY SET FOR USE BY
!*             OTHER SUBROUTINES IN THIS SYSTEM

!*  SUBROUTINE CLL2XY (STRCMP, XLAT,XLONG, X,Y)
!*  SUBROUTINE CXY2LL (STRCMP, X,Y, XLAT,XLONG)
!*     THESE ROUTINES CONVERT BETWEEN MAP COORDINATES X,Y
!*     AND GEOGRAPHIC COORDINATES XLAT,XLONG
!*  INPUTS:
!*     STRCMP(9) - 9-VALUE MAP STRUCTURE ARRAY
!*     FOR CLL2XY:  XLAT,XLONG - GEOGRAPHIC COORDINATES
!*     FOR CXY2LL:  X,Y - MAP COORDINATES
!*  OUTPUTS:
!*     FOR CLL2XY:  X,Y - MAP COORDINATES
!*     FOR CXY2LL:  XLAT,XLONG - GEOGRAPHIC COORDINATES

!*  SUBROUTINE CC2GXY (STRCMP, X,Y, UE,VN, UG,VG)
!*  SUBROUTINE CG2CXY (STRCMP, X,Y, UG,VG, UE,VN)
!*  SUBROUTINE CC2GLL (STRCMP, XLAT,XLONG, UE,VN, UG,VG)
!*  SUBROUTINE CG2CLL (STRCMP, XLAT,XLONG, UG,VG, UE,VN)
!*     THESE SUBROUTINES CONVERT VECTOR WIND COMPONENTS FROM
!*     GEOGRAPHIC, OR COMPASS, COORDINATES, TO MAP OR
!*     GRID COORDINATES.  THE SITE OF THE WIND TO BE
!*     CONVERTED MAY BE GIVEN EITHER IN GEOGRAPHIC OR
!*     MAP COORDINATES.  WIND COMPONENTS ARE ALL IN KILOMETERS
!*     PER HOUR, WHETHER GEOGRAPHIC OR MAP COORDINATES.
!*  INPUTS:
!*    STRCMP(9) - 9-VALUE MAP STRUCTURE ARRAY
!*    FOR CC2GXY AND CG2CXY:  X,Y        -  MAP COORDINATES OF SITE
!*    FOR CC2GLL AND CG2CLL:  XLAT,XLONG -  GEOGRAPHIC COORDINATES OF SITE
!*    FOR CC2GXY AND CC2GLL:  UE,VN - EAST AND NORTH WIND COMPONENTS
!*    FOR CG2CXY AND CG2CLL:  UG,VG - X- AND Y- DIRECTION WIND COMPONENTS
!*  OUTPUTS:
!*    FOR CC2GXY AND CC2GLL:  UG,VG - X- AND Y- DIRECTION WIND COMPONENTS
!*    FOR CG2CXY AND CG2CLL:  UE,VN - EAST AND NORTH WIND COMPONENTS

!*  SUBROUTINE CCRVXY (STRCMP, X, Y,       GX,GY)
!*  SUBROUTINE CCRVLL (STRCMP, XLAT,XLONG, GX,GY)
!*    THESE SUBROUTINES RETURN THE CURVATURE VECTOR (GX,GY), AS REFERENCED
!*    TO MAP COORDINATES, INDUCED BY THE MAP TRANSFORMATION.  WHEN
!*    NON-LINEAR TERMS IN WIND SPEED ARE IMPORTANT, A "GEODESIC" FORCE
!*    SHOULD BE INCLUDED IN THE VECTOR FORM [ (U,U) G - (U,G) U ] WHERE THE
!*    INNER PRODUCT (U,G) IS DEFINED AS UX*GX + UY*GY.
!*  INPUTS:
!*    STRCMP(9) - 9-VALUE MAP STRUCTURE ARRAY
!*    FOR CCRVXY:  X,Y        -  MAP COORDINATES OF SITE
!*    FOR CCRVLL:  XLAT,XLONG -  GEOGRAPHIC COORDINATES OF SITE
!*  OUTPUTS:
!*    GX,GY       - VECTOR COEFFICIENTS OF CURVATURE, IN UNITS RADIANS
!*                  PER KILOMETER

!*  REAL FUNCTION CGSZLL (STRCMP, XLAT,XLONG)
!*  REAL FUNCTION CGSZXY (STRCMP, X,Y)
!*    THESE FUNCTIONS RETURN THE SIZE, IN KILOMETERS, OF EACH UNIT OF
!*    MOTION IN MAP COORDINATES (GRID SIZE).  THE GRID SIZE AT ANY
!*    LOCATION DEPENDS ON THAT LOCATION; THE POSITION MAY BE GIVEN IN
!*    EITHER MAP OR GEOGRAPHIC COORDINATES.
!*  INPUTS:
!*    STRCMP(9) - 9-VALUE MAP STRUCTURE ARRAY
!*    FOR CGSZXY:  X,Y        -  MAP COORDINATES OF SITE
!*    FOR CGSZLL:  XLAT,XLONG -  GEOGRAPHIC COORDINATES OF SITE
!*  RETURNS:
!*    GRIDSIZE IN KILOMETERS AT GIVEN SITE.

!*  SUBROUTINE CPOLXY (STRCMP, X,Y, ENX,ENY,ENZ)
!*  SUBROUTINE CPOLLL (STRCMP, XLAT,XLONG, ENX,ENY,ENZ)
!*    THESE SUBROUTINES PROVIDE 3-D VECTOR COMPONENTS OF A UNIT VECTOR
!*    IN THE DIRECTION OF THE NORTH POLAR AXIS.  WHEN MULTIPLIED
!*    BY TWICE THE ROTATION RATE OF THE EARTH (2 * PI/24 HR), THE
!*    VERTICAL COMPONENT YIELDS THE CORIOLIS FACTOR.
!*  INPUTS:
!*    STRCMP(9) - 9-VALUE MAP STRUCTURE ARRAY
!*    FOR CPOLXY:  X,Y        -  MAP COORDINATES OF SITE
!*    FOR CPOLLL:  XLAT,XLONG -  GEOGRAPHIC COORDINATES OF SITE
!*  RETURNS:
!*    ENX,ENY,ENZ THE DIRECTION COSINES OF A UNIT VECTOR IN THE
!*    DIRECTION OF THE ROTATION AXIS OF THE EARTH

!*  SUBROUTINE CNLLXY (STRCMP, XLAT,XLONG, XI,ETA)
!*  SUBROUTINE CNXYLL (STRCMP, XI,ETA, XLAT,XLONG)
!*    THESE SUBROUTINES PERFORM THE UNDERLYING TRANSFORMATIONS FROM
!*    GEOGRAPHIC COORDINATES TO AND FROM CANONICAL (EQUATOR CENTERED)
!*    COORDINATES.  THEY ARE CALLED BY CXY2LL AND CLL2XY, BUT ARE NOT
!*    INTENDED TO BE CALLED DIRECTLY

!*  REAL FUNCTION CSPANF (VALUE, BEGIN, END)
!*    THIS FUNCTION ASSISTS OTHER ROUTINES IN PROVIDING A LONGITUDE IN
!*    THE PROPER RANGE.  IT ADDS TO VALUE WHATEVER MULTIPLE OF 
!*    (END - BEGIN) IS NEEDED TO RETURN A NUMBER BEGIN < CSPANF <= END

       SUBROUTINE STLMBR(STRCMP, TNGLAT, XLONG)
!*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
       PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
       PARAMETER (REARTH=6371.2)
       REAL STRCMP(9)
       STRCMP(1) = SIN(RADPDG * TNGLAT)
!*  GAMMA = SINE OF THE TANGENT LATITUDE
       STRCMP(2) = CSPANF( XLONG, -180., +180.)
!* LAMBDA_0 = REFERENCE LONGITUDE
       STRCMP(3) = 0.
!* X_0 = X- GRID COORDINATE OF ORIGIN (XI,ETA) = (0.,0.)
       STRCMP(4) = 0.
!* y_0 = Y-GRID COORDINATE OF ORIGIN (XI,ETA) = (0.,0.)
       STRCMP(5) = 1.
!* COSINE OF ROTATION ANGLE FROM XI,ETA TO X,Y
       STRCMP(6) = 0.
!* SINE OF ROTATION ANGLE FROM XI,ETA TO X,Y
       STRCMP(7) = REARTH
!* GRIDSIZE IN KILOMETERS AT THE EQUATOR
       CALL CNLLXY(STRCMP, 89.,XLONG, XI,ETA)
       STRCMP(8) = 2. * ETA - STRCMP(1) * ETA * ETA
!* RADIAL COORDINATE FOR 1 DEGREE FROM NORTH POLE
       CALL CNLLXY(STRCMP, -89.,XLONG, XI,ETA)
          STRCMP(9) = 2. * ETA - STRCMP(1) * ETA * ETA
!* RADIAL COORDINATE FOR 1 DEGREE FROM SOUTH POLE
       RETURN
       END
!
!=====|==1=========2=========3=========4=========5=========6=========7==
!
!$Log: 
