!$Id:
!
!=======================================================================
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ FLEXPART @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!=====|==1=========2=========3=========4=========5=========6=========7==
!
      subroutine fixlayerpart(error)
!*******************************************************************************
!                                                                              *
!     This routine fixes the release times and release locations of all        *
!     particles within a pressure or potential temperature layer.              *
!                                                                              *
!     Author: B. Legras      
!                                                                              *
!     01 February 2004                                                         *
!
!     mod: 17/02/04: add tolerance to boundaries
!                                                                              *
!*******************************************************************************
!                                                                              *
! Variables:                                                                   *
!                                                                              *
!*******************************************************************************

      use commons
      implicit none

      real xc,yc, zc, epsil, epsil2, ylat, pint, lev,X,Y,P 
      real corrected_mesh_size
      integer idummy,i,j,it,numparti,count_lon,jl,jy,indz,ix,k
      integer nb_points_latcircle
      real ddx, ddy, rddx, rddy, p1, p2, p3, p4, psurf
      logical error
      data idummy/-7/

      error = .false.
      epsil =  1.e-4 ; epsil2=1.e-7
      
      numpart=0 
      print *,'numpoint ',numpoint
      if(make_layer) open(unitpartout,file=trim(path(2))//'release_table')
      if(make_curtain) open(unitpartout2,file=trim(path(2))//'release_table_2')
      if(make_uni3D) open(unitpartout3,file=trim(path(2))//'release_table_3')          !!
      if(make_uni3D) open(unitpartout4,file=trim(path(2))//'release_table_4') 
      print *,'path',path(2)
      do i=1,numpoint
        n_loc = 0
        numparti=numpart+1
        xpoint1(i) = (xpoint1(i)-xlon0)/dx
        xpoint2(i) = (xpoint2(i)-xlon0)/dx
        ypoint1(i) = (ypoint1(i)-ylat0)/dy
        ypoint2(i) = (ypoint2(i)-ylat0)/dy
        mesh_size_lat  = mesh_size_lat/dy
        mesh_size_long = mesh_size_long/dx
        print *,'fixlayerpart > sizes  ',mesh_size_long,mesh_size_lat
        it = ireleasestart(i) - mod(ireleasestart(i),abs(lsynctime)) 
        print *,'fixlayerpart > xpoint ',xpoint1(i),xpoint2(i)
        print *,'fixlayerpart > ypoint ',ypoint1(i),ypoint2(i)
        print *,'fixlayerpart > dx, dy  ',dx,dy
        if ((xpoint1(i) < 0.).or.(xpoint1(i) > nx+epsil2)) go to 999
        if ((xpoint2(i) < 0.).or.(xpoint2(i) > nx+epsil2)) go to 999
        if ((ypoint1(i) < 0.).or.(ypoint1(i) > ny+epsil2)) go to 999
        if ((ypoint2(i) < 0.).or.(ypoint2(i) > ny+epsil2)) go to 999  

! set horizontal locations
! if horizontal spread, number of points along a contour depends on cos of lat
! otherwise it is constant over each latitude circle and latitude is the fast
! variable in the array (unlike usual conventions)
        if (uniform_spread) then
          if(make_uni3D) then
            yc = ypoint1(i)
            do while (yc <= ypoint2(i)+epsil)
               jy=floor(yc)
               ylat = (ylat0 + yc*dy)*pi/180.
!              print *, 'fixlayerpartM > ylat ',ylat
               xc = xpoint1(i)
               count_lon=0
               if (uniform_mesh) then
                 nb_points_latcircle = int(nx*abs(cos(ylat))/mesh_size_long)
                 if(nb_points_latcircle>0) then
                   corrected_mesh_size = float(nx)/nb_points_latcircle
                 else 
                   corrected_mesh_size = 2*float(nx) ! set a large value to get only 1 pt on circle
                 endif
               else
                 corrected_mesh_size = mesh_size_long/(abs(cos(ylat))+epsil2)
               endif
               do while (xc <= xpoint2(i)+epsil)
                 n_loc=n_loc+1
                 ix=floor(xc)
                 count_lon=count_lon+1
                 ddx=xc-float(ix) ;  ddy=yc-float(jy)
                 rddx=1.-ddx      ;  rddy=1.-ddy
                 p1=rddx*rddy     ;  p2=ddx*rddy
                 p3=rddx*ddy      ;  p4=ddx*ddy
                 psurf=p1*ps(ix,jy,1,1)+p2*ps(ix+1,jy,1,1)+p3*ps(ix,jy+1,1,1)+p4*ps(ix+1,jy+1,1,1)
                do lev=lev1,lev2,inclev
                   indz=floor(lev)
                   pint=akz(indz) + bkz(indz)*psurf &
                      + (lev-indz)*(akz(indz+1)-akz(indz)+psurf*(bkz(indz+1)-bkz(indz)))
                   zc=log(p0/pint)

                   do j=1,nsample(i)
                     numpart = numpart+1
                     if(numpart > maxpart) go to 996
                        call RANDOM_NUMBER(X)
                        X=(2*X-1)*corrected_mesh_size
                        xtra1(numpart) = xc+X
                        call RANDOM_NUMBER(Y)
                        Y=(2*Y-1)*mesh_size_lat
                        ytra1(numpart) = yc+Y
                        call RANDOM_NUMBER(P)
                        P=(2*P-1)*inclev
                       ztra1(numpart) = zc+P
                    enddo
                 !write for keeping zc and the other parameters
                write(unitpartout4,'(8G15.6)') ylat0+yc*dx,xlon0,corrected_mesh_size*dx,count_lon,zc,lev1,lev2,inclev
                 enddo
                !pint=0
                !  do k=1,24
                  !pint=k*10+280
                !   pint=k*0.25
                !  do j=1,nsample(i)
                !    numpart = numpart+1
                !    if(numpart > maxpart) go to 996
                !    call RANDOM_NUMBER(X)
                !    X=(2*X-1)*corrected_mesh_size
                !    xtra1(numpart) = xc+X
                !    call RANDOM_NUMBER(Y)
                !    Y=(2*Y-1)*mesh_size_lat
                !    ytra1(numpart) = yc+Y
                !    call RANDOM_NUMBER(P)
                !    P=(2*P-1)*0.25
                !    ztra1(numpart) = pint+P
                !  enddo
                 !!write(*,*) 'lon=',xc,xtra1(numpart),'lat=',yc,ytra1(numpart),'z=',pint,ztra1(numpart), nsample(i)
                ! enddo
                ! write(*,*) 'lon=',xc,xtra1(numpart),'lat=',yc,ytra1(numpart),'z=',pint,ztra1(numpart)
          
                 xc = xc + corrected_mesh_size
               enddo
               write(unitpartout3,'(8G15.6)') ylat0+yc*dx,xlon0,corrected_mesh_size*dx,count_lon,zc,lev1,lev2,inclev
               yc = yc+mesh_size_lat
            enddo
            print *,'fixlayerpart > numpart after make_uni3D ',numpart
          endif

          if(make_layer) then
            yc = ypoint1(i)
            do while (yc <= ypoint2(i)+epsil)
               ylat = (ylat0 + yc*dy)*pi/180.
               xc = xpoint1(i)
               count_lon=0
               if (uniform_mesh) then
                 nb_points_latcircle = int(nx*abs(cos(ylat))/mesh_size_long)
                 if(nb_points_latcircle>0) then
                   corrected_mesh_size = float(nx)/nb_points_latcircle
                 else 
                   corrected_mesh_size = 2*float(nx) ! set a large value to get only 1 pt on circle
                 endif
               else
                 corrected_mesh_size = mesh_size_long/(abs(cos(ylat))+epsil2)
               endif
               do while (xc <= xpoint2(i)+epsil)
                 n_loc=n_loc+1
                 count_lon=count_lon+1  
                 do j=1,nsample(i)
                   numpart = numpart+1 
                   if(numpart > maxpart) go to 996
                   xtra1(numpart) = xc
                   ytra1(numpart) = yc
                   ztra1(numpart) = zpoint1(i)
                 enddo
                 xc = xc + corrected_mesh_size
               enddo
               write(unitpartout,'(4G15.6)') ylat0+yc*dx,xlon0,corrected_mesh_size*dx,count_lon
               yc = yc+mesh_size_lat
            enddo
            print *,'fixlayerpart > numpart after make_layer ',numpart
          endif
!         Adding vertical curtains of parcel at selected latitudes (only available under uniform spread

          if (make_curtain) then
             do jl=1,size(lat_list)
               ylat = lat_list(jl)*pi/180.   
               yc = (lat_list(jl)-ylat0)/dy
               jy = floor(yc)
               if (uniform_mesh) then
                 nb_points_latcircle = int(nx*abs(cos(ylat))/mesh_size_long)
                 if(nb_points_latcircle>0) then
                   corrected_mesh_size = float(nx)/nb_points_latcircle
                 else 
                   corrected_mesh_size = 2*float(nx) ! set a large value to get only 1 pt on circle
                 endif
               else
                 corrected_mesh_size = mesh_size_long/(abs(cos(ylat))+epsil2)
               endif
               do lev=lev1,lev2,inclev
                 indz=floor(lev)
                 pint=akz(indz) + bkz(indz)*p0 &
                     + (lev-indz)*(akz(indz+1)-akz(indz)+p0*(bkz(indz+1)-bkz(indz)))
                 zc=log(p0/pint)
                 xc=xpoint1(i)
                 count_lon=0
                 do while (xc <= xpoint2(i)+epsil)
                   count_lon=count_lon+1
                   do j=1,nsample(i)
                     numpart = numpart+1
                     if(numpart > maxpart) go to 996
                     xtra1(numpart) = xc
                     ytra1(numpart) = yc
                     ztra1(numpart) = zc
                   enddo
                   xc = xc + corrected_mesh_size
                 enddo
                 write(unitpartout2,'(5G15.6)') ylat0+yc*dx,xlon0,corrected_mesh_size*dx,count_lon,zc
               enddo
             enddo
          endif 

        else  
          xc = xpoint1(i)
          do while (xc <= xpoint2(i)+epsil)
             yc = ypoint1(i)
             do while (yc <= ypoint2(i)+epsil)
                n_loc = n_loc+1
                do j=1,nsample(i)
                   numpart = numpart+1 
                   if(numpart > maxpart) go to 996
                   xtra1(numpart) = xc
                   ytra1(numpart) = yc
                   ztra1(numpart) = zpoint1(i)
                enddo
                yc = yc+mesh_size_lat
             enddo
             xc = xc+mesh_size_long
             !----------- temporary test
             if((xc.lt.0).or.(xc.gt.nx-1)) then
                print *,'fixlayerpart > ALARM!!: xc ',xc
             endif
             !-----------        
          enddo
        endif
! set vertical positions and initialise time
        do j=numparti,numpart          
          itra1(j) = it
          itramem(j) = it
        enddo
      enddo
      if(make_layer) close(unitpartout)
      if(make_curtain) close(unitpartout2)
      if(make_uni3D) close(unitpartout3)
      print *,'fixlayerpart > completed, numpart ',numpart
      return

996   error=.true.
      write(*,*) '#####################################################'
      write(*,*) '#### FLEXPART MODEL SUBROUTINE FIXPARTICLES:     ####'
      write(*,*) '####                                             ####'
      write(*,*) '#### ERROR - TOTAL NUMBER OF PARTICLES SPECIFIED ####'
      write(*,*) '#### IN FILE "RELEASES" OR CARRIED FORWARD FROM  ####'
      write(*,*) '#### PREVIOUS RUN EXCEEDS THE MAXIMUM ALLOWED    ####'
      write(*,*) '#### NUMBER. REDUCE EITHER NUMBER OF PARTICLES   ####'
      write(*,*) '#### PER RELEASE POINT OR REDUCE NUMBE OF        ####'
      write(*,*) '#### RELEASE POINTS.                             ####'
      write(*,*) '#####################################################'
      return

999   error=.true.
      write(*,*) '#####################################################'
      write(*,*) '###  ERROR IN THE XPOINT YPOINT INITIALIZATION    ###'
      write(*,*) '#####################################################'
      return

      end subroutine fixlayerpart

 subroutine fixpresslayerpart(error)
!*******************************************************************************
!                                                                              *
!     This routine fixes the release times and release locations of all        *
!     particles within a pressure layer for the case of potential T used       *
!     as vertical coordinate
!                                                                              *
!     Author: B. Legras      
!                                                                              *
!     from fixlayerpart                                                        *
!     04/03/06
!                                                                              *
!*******************************************************************************
!                                                                              *
! Variables:                                                                   *
!                                                                              *
!*******************************************************************************

      use commons
      use mass_iso
      implicit none

      real xc,yc,zc, epsil, epsil2, ylat,X,Y,P
      real theta, thetamax,thetamin,thetainf,thetasup
      real psurf, corrected_mesh_size
      real pint,coef_interp,lev
      real ddx,ddy,rddx,rddy,p1,p2,p3,p4,psurf
      integer idummy,i,j,it,numparti,indz,ix,jy,count_lon,jl
      integer nb_points_latcircle
      logical error
      data idummy/-7/

      error = .false.
      epsil =  1.e-4 ; epsil2 = 1.e-7
      thetamin=10000. ; thetamax=0.

      if(iso_mass) then
        print *,'fixpresslayerpart does not allow to set pressure'
        print *,'in a iso mass run' 
        stop
      endif

      numpart=0 
      print *,'numpoint ',numpoint
      if(make_layer) open(unitpartout,file=trim(path(2))//'release_table')
      if(make_curtain) open(unitpartout2,file=trim(path(2))//'release_table_2')
      if(make_uni3D) open(unitpartout3,file=trim(path(2))//'release_table_3')
      if(make_uni3D) open(unitpartout4,file=trim(path(2))//'release_table_4')
      do i=1,numpoint
        n_loc = 0
        numparti=numpart+1
        xpoint1(i) = (xpoint1(i)-xlon0)/dx
        xpoint2(i) = (xpoint2(i)-xlon0)/dx
        ypoint1(i) = (ypoint1(i)-ylat0)/dy
        ypoint2(i) = (ypoint2(i)-ylat0)/dy
        mesh_size_lat  = mesh_size_lat/dy
        mesh_size_long = mesh_size_long/dx
        print *,'fixpresslayerpart > sizes  ',mesh_size_long,mesh_size_lat
        it = ireleasestart(i) - mod(ireleasestart(i),abs(lsynctime))
        print *,'fixpresslayerpart > xpoint ',xpoint1(i),xpoint2(i)
        print *,'fixpresslayerpart > ypoint ',ypoint1(i),ypoint2(i)
        print *,'fixpresslayerpart > dx, dy  ',dx,dy
        if ((xpoint1(i) < 0.).or.(xpoint1(i) > nx+epsil2)) go to 999
        if ((xpoint2(i) < 0.).or.(xpoint2(i) > nx+epsil2)) go to 999
        if ((ypoint1(i) < 0.).or.(ypoint1(i) > ny+epsil2)) go to 999
        if ((ypoint2(i) < 0.).or.(ypoint2(i) > ny+epsil2)) go to 999  

! set horizontal locations
! if horizontal spread, number of points along a contour depends on cos of lat
! otherwise it is constant over each latitude circle and latitude is the fast
! variable in the array (unlike usual conventions)
        if (uniform_spread) then
          if(make_uni3D) then
            yc = ypoint1(i)
            do while (yc <= ypoint2(i)+epsil)
               ylat = (ylat0 + yc*dy)*pi/180.
               jy = floor(yc)
!              print *, 'fixpresslayerpart > ylat ',ylat
               xc = xpoint1(i)
               count_lon=0
               if (uniform_mesh) then
                 nb_points_latcircle = int(nx*abs(cos(ylat))/mesh_size_long)
                 if(nb_points_latcircle>0) then
                   corrected_mesh_size = float(nx)/nb_points_latcircle
                 else 
                   corrected_mesh_size = 2*float(nx) ! set a large value to get only 1 pt on circle
                 endif
               else
                 corrected_mesh_size = mesh_size_long/(abs(cos(ylat))+epsil2)
               endif
               do while (xc <= xpoint2(i)+epsil)
                 n_loc=n_loc+1
                 count_lon=count_lon+1
                 ix = floor(xc)
                 ddx=xc-float(ix) ;  ddy=yc-float(jy)
                 rddx=1.-ddx      ;  rddy=1.-ddy
                 p1=rddx*rddy     ;  p2=ddx*rddy
                 p3=rddx*ddy      ;  p4=ddx*ddy
                 psurf=p1*ps(ix,jy,1,1)+p2*ps(ix+1,jy,1,1)+p3*ps(ix,jy+1,1,1)+p4*ps(ix+1,jy+1,1,1)
                 
                 pint=0
                 do lev=lev1,lev2,inclev
                    indz=floor(lev)
                    pint=akz(indz) + bkz(indz)*psurf&
                       + (lev-indz)*(akz(indz+1)-akz(indz)+psurf*(bkz(indz+1)-bkz(indz)))
                    thetasup=tth(ix,jy,indz+1,1)*(p0/(akz(indz+1) + bkz(indz+1)*psurf))**kappa
                    thetainf=tth(ix,jy,indz  ,1)*(p0/(akz(indz  ) + bkz(indz  )*psurf))**kappa
                    theta=thetainf+(lev-indz)*(thetasup-thetainf)
                    theta=min(theta,upperthetalevel) 
                    thetamin=min(theta,thetamin)
                    thetamax=max(theta,thetamax)
                !    do j=1,nsample(i)
                !      numpart = numpart+1
                !      if(numpart > maxpart) go to 996
                !       xtra1(numpart) = xc
                !       ytra1(numpart) = yc
                !       ztra1(numpart) = theta
                !     enddo
                  !! write for keeping pint,and the others parameters
                ! write(unitpartout4,'(9G15.6)') ylat0+yc*dx,xlon0,corrected_mesh_size*dx,count_lon,theta,lev1,lev2,inclev,pint
                !  enddo
                  
                !  pint=lev*0.25
                  do j=1,nsample(i)
                    numpart = numpart+1
                    if(numpart > maxpart) go to 996
                    call RANDOM_NUMBER(X)
                    X=(2*X-1)*corrected_mesh_size
                    xtra1(numpart) = xc+X
                    call RANDOM_NUMBER(Y)
                    Y=(2*Y-1)*mesh_size_lat
                    ytra1(numpart) = yc+Y
                    call RANDOM_NUMBER(P)
                    P=(2*P-1)*0.25
                    ztra1(numpart) = theta+P
                  enddo
                 !write(*,*) 'lon=',xc,xtra1(numpart),'lat=',yc,ytra1(numpart),'z=',pint,ztra1(numpart), nsample(i)
                 enddo
                 write(*,*) 'lon=',xc,xtra1(numpart),'lat=',yc,ytra1(numpart),'z=',pint,ztra1(numpart)

                 xc = xc + corrected_mesh_size
                 enddo
               write(unitpartout3,'(8G15.6)') ylat0+yc*dx,xlon0,corrected_mesh_size*dx,count_lon,theta
               yc = yc+mesh_size_lat
            enddo
            print *,'fixpresslayerpart > numpart after make_uni3D ',numpart
          endif

          if(make_layer) then
!       find the ecmwf levels bracketting the chosen pressure level
!       we assume that initialization is done at an altitude for which
!       levels are pure pressure levels
!       If this is not the case, calculate indz inside the loop on xc, yc
!       with pint calculated
            pint=p0*exp(-zpoint1(i))
            indz=locuv(1,nuvz,p0)
            coef_interp=(pint- akz(indz+1) - bkz(indz+1)*p0) &
                   /(akz(indz)-akz(indz+1)+p0*(bkz(indz)-bkz(indz+1)))
            print *,'fixpresslayerpart > coef_interp, ',coef_interp
            yc = ypoint1(i)
            do while (yc <= ypoint2(i)+epsil)
               ylat = (ylat0 + yc*dx)*pi/180.
               xc = xpoint1(i)
               count_lon=0
               if (uniform_mesh) then
                 nb_points_latcircle = int(nx*abs(cos(ylat))/mesh_size_long)
                 if(nb_points_latcircle>0) then
                   corrected_mesh_size = float(nx)/nb_points_latcircle
                 else 
                   corrected_mesh_size = 2*float(nx) ! set a large value to get only 1 pt on circle
                 endif
               else
                 corrected_mesh_size = mesh_size_long/(abs(cos(ylat))+epsil2)
               endif
               do while (xc <= xpoint2(i)+epsil)
                 n_loc=n_loc+1
                 count_lon=count_lon+1
                 ix=floor(xc); jy=floor(yc)
                 thetasup=tth(ix,jy,indz+1,1)*(p0/(akz(indz+1) + bkz(indz+1)*p0))**kappa
                 thetainf=tth(ix,jy,indz  ,1)*(p0/(akz(indz  ) + bkz(indz  )*p0))**kappa
                 theta=thetasup+(thetainf-thetasup)*coef_interp
                 thetamax=max(theta,thetamax) ; thetamin=min(theta,thetamin)      
                 do j=1,nsample(i)
                   numpart = numpart+1 
                   if(numpart > maxpart) go to 996
                   xtra1(numpart) = xc
                   ytra1(numpart) = yc
                   ztra1(numpart) = theta
                 enddo
                 xc = xc + corrected_mesh_size
               enddo
               write(unitpartout,'(4G15.6)') ylat0+yc*dx,xlon0,corrected_mesh_size*dx,count_lon
               yc = yc+mesh_size_lat
            enddo
            print *,'fixpresslayerpart > numpart after make_layer ',numpart
          endif

!         Adding vertical curtains of parcel at selected latitudes (only available under uniform spread)
          if (make_curtain) then
             do jl=1,size(lat_list)
               ylat = lat_list(jl)*pi/180.   
               yc = (lat_list(jl)-ylat0)/dy
               jy = floor(yc)
               if (uniform_mesh) then
                 nb_points_latcircle = int(nx*abs(cos(ylat))/mesh_size_long)
                 if(nb_points_latcircle>0) then
                   corrected_mesh_size = float(nx)/nb_points_latcircle
                 else 
                   corrected_mesh_size = 2*float(nx) ! set a large value to get only 1 pt on circle
                 endif
               else
                 corrected_mesh_size = mesh_size_long/(abs(cos(ylat))+epsil2)
               endif
               do lev=lev1,lev2,inclev
                 indz=floor(lev)
                 pint=akz(indz) + bkz(indz)*p0 &
                     + (lev-indz)*(akz(indz+1)-akz(indz)+p0*(bkz(indz+1)-bkz(indz)))
                 xc=xpoint1(i)
                 count_lon=0
                 do while (xc <= xpoint2(i)+epsil)
                   count_lon=count_lon+1
                   ix = floor(xc)
                   thetasup=tth(ix,jy,indz+1,1)*(p0/(akz(indz+1) + bkz(indz+1)*p0))**kappa
                   thetainf=tth(ix,jy,indz  ,1)*(p0/(akz(indz  ) + bkz(indz  )*p0))**kappa
                   theta=thetainf+(lev-indz)*(thetasup-thetainf)
                   theta=min(theta,upperthetalevel) ! bounded by the max value of theta in iso_mas
                   do j=1,nsample(i)
                     numpart = numpart+1
                     if(numpart > maxpart) go to 996
                     xtra1(numpart) = xc
                     ytra1(numpart) = yc
                     ztra1(numpart) = theta
                   enddo
                   xc = xc + corrected_mesh_size
                 enddo
                 write(unitpartout2,'(5G15.6)') ylat0+yc*dx,xlon0,corrected_mesh_size*dx,count_lon,pint
               enddo
             enddo
          endif 

        else  
          pint=p0*exp(-zpoint1(i))
          indz=locuv(1,nuvz,p0)
          coef_interp=(pint- akz(indz+1) - bkz(indz+1)*p0) &
                   /(akz(indz)-akz(indz+1)+p0*(bkz(indz)-bkz(indz+1)))
          xc = xpoint1(i) 
          print *,'fixpresslayerpart > xpoint ',xpoint1(i),xpoint2(i)
          do while (xc <= xpoint2(i)+epsil)
             yc = ypoint1(i) 
             do while (yc <= ypoint2(i)+epsil)
                n_loc = n_loc+1
                ix=int(xc); jy=int(yc)
                thetasup=tth(ix,jy,indz+1,1)*(p0/(akz(indz+1) + bkz(indz+1)*p0))**kappa
                thetainf=tth(ix,jy,indz  ,1)*(p0/(akz(indz  ) + bkz(indz  )*p0))**kappa
                theta=thetasup+(thetainf-thetasup)*coef_interp
                thetamax=max(theta,thetamax) ; thetamin=min(theta,thetamin)
                do j=1,nsample(i)
                   numpart = numpart+1 
                   if(numpart > maxpart) go to 996
                   xtra1(numpart) = xc
                   ytra1(numpart) = yc
                   ztra1(numpart) = theta
                enddo
                yc = yc+mesh_size_lat
             enddo
             !----------- temporary test
             if((xc.lt.0).or.(xc.gt.nx-1)) then
                print *,'fixpresslayerpart > ALARM!!: xc ',xc
             endif
             !-----------
             xc = xc+mesh_size_long
          enddo
        endif      
        do j=numparti,numpart
          itra1(j) = it
          itramem(j) = it
        enddo
      enddo
      if(make_layer) close(unitpartout)
      if(make_curtain) close(unitpartout2)
      if(make_uni3D) close(unitpartout3)
      print *,'fixpresslayerpart > completed, numpart ',numpart
      print *,'fixpresslayerpart > thetamin, thetamax ',thetamin,thetamax
      return

996   error=.true.
      write(*,*) '#####################################################'
      write(*,*) '#### FLEXPART MODEL SUBROUTINE FIXPARTICLES:     ####'
      write(*,*) '####                                             ####'
      write(*,*) '#### ERROR - TOTAL NUMBER OF PARTICLES SPECIFIED ####'
      write(*,*) '#### IN FILE "RELEASES" OR CARRIED FORWARD FROM  ####'
      write(*,*) '#### PREVIOUS RUN EXCEEDS THE MAXIMUM ALLOWED    ####'
      write(*,*) '#### NUMBER. REDUCE EITHER NUMBER OF PARTICLES   ####'
      write(*,*) '#### PER RELEASE POINT OR REDUCE NUMBE OF        ####'
      write(*,*) '#### RELEASE POINTS.                             ####'
      write(*,*) '#####################################################'
      return

999   error=.true.
      write(*,*) '#####################################################'
      write(*,*) '###   ERROR IN THE XPOINT YPOINT INITIALIZATION   ###'
      write(*,*) '#####################################################'
      return

!************************************
      contains
!************************************     

      function locuv(ib1,iu1,psu)
      integer, intent(in) :: ib1,iu1
      real, intent(in) :: psu
      integer :: locuv,ib,iu,im
      real :: pm
      ib=ib1 ; iu=iu1
      do while(iu-ib>1)
        im = (iu+ib)/2
        pm = akz(im) + bkz(im)*psu
        if( pm >= pint ) then
          ib=im
        else
          iu=im
        endif
      enddo
      if (bkz(ib) > 0.) then
         print *,'WARNING: initialization within sigma range'
         print *,'inaccurate conversion of theta to p'
      endif
      locuv = ib
      end function locuv


      end subroutine fixpresslayerpart
!
!=====|==1=========2=========3=========4=========5=========6=========7==
!
!$Log: 
