!$Id:
!
!=======================================================================
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ FLEXPART @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!=====|==1=========2=========3=========4=========5=========6=========7==
!
      subroutine fixparticlesB(error)
!*******************************************************************************
!                                                                              *
!     This routine fixes the release times and release locations of all        *
!     particles. It also attributes the mass to individual particles.          *
!                                                                              *
!     Author: A. Stohl                                                         
!                                                                              *
!     18 May 1996                                                              *
!
!     Changes: B. Legras, Apr. 2002
!              version for distribution along a profile
!                                                                              *
!*******************************************************************************
!                                                                              *
! Variables:                                                                   *
! ideltas [s]          simulation period                                       *
!                                                                              *
!*******************************************************************************

      use commons
      implicit none

      real thelp,xaux,yhelp,zhelp
      integer idummy,i,j1,j2,ih
      logical error
      data idummy/-7/

      error=.false.
      
      numpart=0
      do i=1,numpoint
        thelp=float(ireleaseend(i)-ireleasestart(i))/float(npart(i))
        xaux=xpoint2(i)-xpoint1(i)
        yhelp=ypoint2(i)-ypoint1(i)
        zhelp=log(zpoint2(i)/zpoint1(i))/(numlevel(i)-1)
        do j1=1,numlevel(i)
          do j2=1,nsample(i)
            numpart=numpart+1
            if (numpart.gt.maxpart) goto 996
!fossil            nclass(numpart)=min(int(ran1(idummy)*float(nclassunc))+1, &
!fossil            nclassunc)
            xtra1(numpart)=xpoint1(i)
            ytra1(numpart)=ypoint1(i)
            ztra1(numpart)=-(log(zpoint1(i)/p0)+j1*zhelp)
!           print *,numpart,xtra1(numpart),ytra1(numpart),ztra1(numpart)
            itra1(numpart)=ireleasestart(i)+int((0.5+float(j1-1))*thelp)
            ih=mod(itra1(numpart),abs(lsynctime)) ! only intervals of lsynctime
            itra1(numpart)=itra1(numpart)-ih    ! seconds are allowed
            itramem(numpart)=itra1(numpart)
!           itrasplit(numpart)=itra1(numpart)+ldirect*itsplit
          enddo
        enddo
      enddo 
      print *,'fixparticlesB > completed, numpart ',numpart
      return

996   error=.true.
      write(*,*) '#####################################################'
      write(*,*) '#### FLEXPART MODEL SUBROUTINE FIXPARTICLES:     ####'
      write(*,*) '####                                             ####'
      write(*,*) '#### ERROR - TOTAL NUMBER OF PARTICLES SPECIFIED ####'
      write(*,*) '#### IN FILE "RELEASES" OR CARRIED FORWARD FROM  ####'
      write(*,*) '#### PREVIOUS RUN EXCEEDS THE MAXIMUM ALLOWED    ####'
      write(*,*) '#### NUMBER. REDUCE EITHER NUMBER OF PARTICLES   ####'
      write(*,*) '#### PER RELEASE POINT OR REDUCE NUMBE OF        ####'
      write(*,*) '#### RELEASE POINTS.                             ####'
      write(*,*) '#####################################################'
      return

      end
!
!=====|==1=========2=========3=========4=========5=========6=========7==
!
!$Log: 
