!$Id: 
!
!=======================================================================
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ FLEXPART @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!=====|==1=========2=========3=========4=========5=========6=========7==
!
      subroutine partout_agef(itime)
!                          i
!*******************************************************************************
!                                                                              *
!     Dump all particle positions in 32 bits IEEE
!     plus temperature
!                                                                              *
!     Author: B. Legras                                                        *
!                                                                              *
!     derived form partout_qv
!     2 September 2012     
!                                                                              *
!*******************************************************************************
!                                                                              *
! Variables:                                                                   *
!                                                                              *
!*******************************************************************************

      use commons
      implicit none

      integer, intent(in):: itime
      integer i,outfmt,lhead
      integer ihour,nact     
      integer (kind=4), allocatable:: itra(:),idx(:)
      real (kind=4), allocatable:: xyzt(:,:)
      character(len=6):: chour

      ihour=abs(itime)/3600
      if(ihour < 1000) then
        write(chour,'(I3.3)') ihour
      else if(ihour < 10000) then
        write(chour,'(I4.4)') ihour
      else if(ihour < 100000) then
        write(chour,'(I5.5)') ihour
      else
        write(chour,'(I6.6)') ihour
      endif

!     Generates a reduced file with all the active parcels
      nact=0
      allocate (itra(maxpart),idx(maxpart),xyzt(4,maxpart))
      dopart: do i=1,numpart
        if(itra1(i)==itime) then
          nact=nact+1
          idx(nact)=i
          itra(nact)=itra0(i)
          xyzt(1,nact)=xlon0+xtra1(i)*dx
          xyzt(2,nact)=ylat0+ytra1(i)*dy
          xyzt(3,nact)=ztra1(i)
          xyzt(4,nact)=ttra1(i)
        endif
      enddo dopart
      
! Output all particles  
!*************************************

      outfmt=105        ! Output format
      lhead = 5        ! Header length (# of lines)
      open(unitpartout,file=trim(path(2))//'part_'//trim(chour),  &
          form='unformatted')
      call writesngl(unitpartout,(/ lhead, outfmt /))
      call writesngl(unitpartout,(/ nact, numpart/))
      write(unitpartout) release_plan
      call writesngl(unitpartout,(/ ibdate, ibtime /))
      call writesngl(unitpartout,(/ itime /))
      write(unitpartout) (xyzt(1:4,i),idx(i),itra(i),i=1,nact)
      close(unitpartout)
      print *,'partout_agef> part_',chour,'  ',nact,' particles  ', &
              itime/86400,' days'
      deallocate (xyzt,itra,idx)
      return
      contains
      
      subroutine writesngl(unit,datas)
! This routine is used to write integer heading in 32 bits
! 
      integer unit
      integer mm
      integer, dimension(:):: datas
      integer(kind=4):: ii(10)
      mm = size(datas) ; if (mm > 10) mm=10
      ii(1:mm) = datas(1:mm)
      write(unit) ii(1:mm)
      end subroutine writesngl
      end subroutine partout_agef
!
!=====|==1=========2=========3=========4=========5=========6=========7==
!
!$Log: 
