!$Id: 
!
!=======================================================================
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ FLEXPART @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!=====|==1=========2=========3=========4=========5=========6=========7==
!
      subroutine partout_fast(itime)
!                          i
!*******************************************************************************
!                                                                              *
!     Dump all particle positions in 32 bits IEEE                              *
!                                                                              *
!     Author: B. Legras                                                        *
!                                                                              *
!     05 October 2001                                                          *
!     modifified: 10 January 2004      
!                                                                              *
!*******************************************************************************
!                                                                              *
! Variables:                                                                   *
!                                                                              *
!*******************************************************************************

      use commons
      implicit none

      integer itime,i1,i2,j,jseg,if,i,outfmt,lhead
      integer ihour,jjjjmmdd,ihmmss,nbuf,try,ierr      
      integer (kind=4), allocatable:: itra(:)
      real (kind=4), allocatable:: xyz(:,:)
      character(len=6):: chour

      ihour=abs(itime)/3600
      if(ihour < 1000) then
        write(chour,'(I3.3)') ihour
      else if(ihour < 10000) then
        write(chour,'(I4.4)') ihour
      else if(ihour < 100000) then
        write(chour,'(I5.5)') ihour
      else
        write(chour,'(I6.6)') ihour
      endif
   
! Output all particles  
!*************************************

      outfmt=102        ! Output format
      lhead = 6         ! Header length (# of lines)
      nbuf=100000
      try=1
 110  open(unitpartout,file=trim(path(2))//'part_'//trim(chour),  &
          form='unformatted',ERR=150)
      call writesngl(unitpartout,(/ lhead, outfmt /),ierr)
      if(ierr==1) go to 150
      call writesngl(unitpartout,(/ nbuf /),ierr)
      if(ierr==1) go to 150
      call writesngl(unitpartout,(/ ibdate, ibtime /),ierr)
      if(ierr==1) go to 150
      call caldate(bdate,jjjjmmdd,ihmmss)
      call writesngl(unitpartout,(/ jjjjmmdd, ihmmss /),ierr)
      if(ierr==1) go to 150
      call writesngl(unitpartout,(/ numpart,numlevel(1),nsample(1) /),ierr)
      if(ierr==1) go to 150
      call writesngl(unitpartout,(/ itime /),ierr)
      if(ierr==1) go to 150
      allocate (xyz(3,nbuf),itra(nbuf))
      jseg=numpart/nbuf 
      i1=1 ; i2=nbuf ; if=nbuf
      do j=1, jseg       
         xyz(1,1:if)=xlon0+xtra1(i1:i2)*dx
         xyz(2,1:if)=ylat0+ytra1(i1:i2)*dy
         xyz(3,1:if)=ztra1(i1:i2)
         itra( 1:if)=itra1(i1:i2)
         write(unitpartout,ERR=150) (xyz(1:3,i),itra(i),i=1,if)
         i1=i1+if ; i2=i2+if
      enddo
      if(if*jseg<numpart) then
        i2=numpart ; if=i2-i1+1
        xyz(1,1:if)=xlon0+xtra1(i1:i2)*dx
        xyz(2,1:if)=ylat0+ytra1(i1:i2)*dy
        xyz(3,1:if)=ztra1(i1:i2)
        itra( 1:if)=itra1(i1:i2)
        write(unitpartout,ERR=150)   &
            (xyz(1:3,i),itra(i),i=1,if)
      endif
      print *,'partout_fast> part_',chour,'  ',itime/86400, &
         ' days, format 102'
      close(unitpartout)
      deallocate (xyz,itra)
      return
 150  close(unitpartout)
      print *,'partout_fast> ERROR in opening or writing'
      try=try+1
      if(try==5) then
        print *, ' PARTOUT_FAST'
        print *, ' give up after 5 attempt to write'
        stop 1000
      else
        go to 110
      endif

      contains
      
      subroutine writesngl(unit,datas,ierr)
! This routine is used to write integer heading in 32 bits
! 
      integer unit, ierr
      integer mm
      integer, dimension(:):: datas
      integer(kind=4):: ii(10)
      mm = size(datas) ; if (mm > 10) mm=10
      ii(1:mm) = datas(1:mm)
      write(unit,ERR=120) ii(1:mm)
      ierr=0
      return
 120  ierr=1     
      end subroutine writesngl
      end subroutine partout_fast
!
!=====|==1=========2=========3=========4=========5=========6=========7==
!
!$Log: 
