!$Id: 
!
!=======================================================================
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ FLEXPART @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!=====|==1=========2=========3=========4=========5=========6=========7==
!
      subroutine partout_qv(itime)
!                          i
!*******************************************************************************
!                                                                              *
!     Dump all particle positions in 32 bits IEEE
!     plus temperature and saturation ratio
!                                                                              *
!     Author: B. Legras                                                        *
!                                                                              *
!     derived form partout_fast
!     2 February 2004     
!                                                                              *
!*******************************************************************************
!                                                                              *
! Variables:                                                                   *
!                                                                              *
!*******************************************************************************

      use commons
      implicit none

      integer, intent(in):: itime
      integer i1,i2,j,jseg,iff,i,outfmt,lhead
      integer ihour,jjjjmmdd,ihmmss,nbuf      
      integer (kind=4), allocatable:: itra(:)
      real (kind=4), allocatable:: xyztq(:,:)
      character(len=6):: chour

      ihour=abs(itime)/3600
      if(ihour < 1000) then
        write(chour,'(I3.3)') ihour
      else if(ihour < 10000) then
        write(chour,'(I4.4)') ihour
      else if(ihour < 100000) then
        write(chour,'(I5.5)') ihour
      else
        write(chour,'(I6.6)') ihour
      endif

   
! Output all particles  
!*************************************

      outfmt=103        ! Output format
      lhead = 6         ! Header length (# of lines)
      nbuf=100000
      open(unitpartout,file=trim(path(2))//'part_'//trim(chour),  &
          form='unformatted')
      call writesngl(unitpartout,(/ lhead, outfmt /))
      call writesngl(unitpartout,(/ nbuf /))
      call writesngl(unitpartout,(/ ibdate, ibtime /))
      call caldate(bdate,jjjjmmdd,ihmmss)
      call writesngl(unitpartout,(/ jjjjmmdd, ihmmss /))
      call writesngl(unitpartout,(/ numpart,n_loc,n_sample /))
      call writesngl(unitpartout,(/ itime /))
      allocate (xyztq(5,nbuf),itra(nbuf))
      jseg=numpart/nbuf 
      i1=1 ; i2=nbuf ; iff=nbuf
      do j=1, jseg       
         xyztq(1,1:iff)=xlon0+xtra1(i1:i2)*dx
         xyztq(2,1:iff)=ylat0+ytra1(i1:i2)*dy
         xyztq(3,1:iff)=ztra1(i1:i2)
         xyztq(4,1:iff)=ttra1(i1:i2)
         xyztq(5,1:iff)=qtra1(i1:i2)
         itra( 1:iff)=itra1(i1:i2)
         write(unitpartout) (xyztq(1:5,i),itra(i),i=1,iff)
         i1=i1+iff ; i2=i2+iff
      enddo
      if(iff*jseg<numpart) then
        i2=numpart ; iff=i2-i1+1
        xyztq(1,1:iff)=xlon0+xtra1(i1:i2)*dx
        xyztq(2,1:iff)=ylat0+ytra1(i1:i2)*dy
        xyztq(3,1:iff)=ztra1(i1:i2)
        xyztq(4,1:iff)=ttra1(i1:i2)
        xyztq(5,1:iff)=qtra1(i1:i2)
        itra( 1:iff)=itra1(i1:i2)
        write(unitpartout) (xyztq(1:5,i),itra(i),i=1,iff)
      endif
      close(unitpartout)
      print *,'partout_qv> part_',chour,'  ',itime/86400, &
           ' days, format 103'
      deallocate (xyztq,itra)
      return
      contains
      
      subroutine writesngl(unit,datas)
! This routine is used to write integer heading in 32 bits
! 
      integer unit
      integer mm
      integer, dimension(:):: datas
      integer(kind=4):: ii(10)
      mm = size(datas) ; if (mm > 10) mm=10
      ii(1:mm) = datas(1:mm)
      write(unit) ii(1:mm)
      end subroutine writesngl
      end subroutine partout_qv
!
!=====|==1=========2=========3=========4=========5=========6=========7==
!
!$Log: 
