!$Id: 
!
!=======================================================================
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ FLEXPART @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!=====|==1=========2=========3=========4=========5=========6=========7==
!
      subroutine restartpart(error)
!                          
!*******************************************************************************
!                                                                              *
!     Restart the calculation from saved archive in 32 bits IEEE
!     or from the last saved point
!                                                                              *
!     Author: B. Legras                                                        *
!                                                                              *
!     27 June   2002
!     modified: 12 January 2004, 26 January 2004, 2 September 2012
!
!     note that for the format 103, qvs is not read, hence the run cannot
!     proceed in the same way as if it was not interrupted
!     pb: qvs is only defined in timemanager 
!     See notes on TRACZILLA
!                                                                              *
!*******************************************************************************
!                                                                              *
! Variables:                                                                   *
!                                                                              *
!*******************************************************************************

      use commons
      implicit none

      integer i1,i2,if,i,j,jseg,nbuf,ir
      integer ibdate_arch,ibtime_arch,lhead,outfmt
      integer (kind=4), allocatable:: itra(:),idx(:)
      real (kind=4), allocatable:: xyz(:,:)
      integer (kind=4):: ddin(3)
      character(len=6):: chour
      character(len=12):: r_plan
      logical,intent(out):: error

      error=.false.
      print *,'##### restart run ####' 
   
! Open the file  
!*************************************
 
      if(hrstart == 0) then 
        call restartfromsav(error)
        return
      endif
      if(hrstart < 1000) then
        write(chour,'(I3.3)') hrstart
      else if(hrstart < 10000) then
        write(chour,'(I4.4)') hrstart
      else if(hrstart < 100000) then
        write(chour,'(I5.5)') hrstart
      else
        write(chour,'(I6.6)') hrstart
      endif
      open(unitpartin,file=trim(path(2))//'part_'//trim(chour), &
         form='unformatted',status='old')
      print *,'restart > opened file'
      read(unitpartin) ddin(1), ddin(2)
      lhead = ddin(1); outfmt = ddin(2)
      if (lhead > 1000) then
        print *,'restart > old raw format detected'
        ibdate_arch = lhead ; ibtime_arch = outfmt
        read(unitpartin)
        read(unitpartin)
        read(unitpartin)
        read(unitpartin) 
        numpart = ddin(1); numlevel(1) = ddin(2); nsample(1) = ddin(3)
        read(unitpartin) ddin(1)
        itime0 = ddin(1)
        nbuf=1000
        outfmt=100
      else
        select case (outfmt)
        case (101)
          nbuf=1000
          read(unitpartin) ddin(1), ddin(2)
          ibdate_arch = ddin(1); ibtime_arch = ddin(2)
          read(unitpartin)
          read(unitpartin)
          read(unitpartin)
          read(unitpartin) ddin(1), ddin(2), ddin(3) 
          numpart = ddin(1); numlevel(1) = ddin(2); nsample(1) = ddin(3)
          read(unitpartin) ddin(1)
          itime0 = ddin(1)
        case (102,103)
          read(unitpartin) ddin(1)
          nbuf = ddin(1)
          read(unitpartin) ddin(1), ddin(2) 
          ibdate_arch = ddin(1); ibtime_arch = ddin(2)
          read(unitpartin)
          read(unitpartin) ddin(1), ddin(2), ddin(3)
          numpart = ddin(1); numlevel(1) = ddin(2); nsample(1) = ddin(3)
          read(unitpartin) ddin(1)
          itime0 = ddin(1)
        case (105)
          read(unitpartin) ddin(1), ddin(2)
          nbuf = ddin(1)
          numpart = ddin(2)
          read(unitpartin) r_plan
          read(unitpartin) ddin(1), ddin(2)
          ibdate_arch = ddin(1); ibtime_arch = ddin(2)
          read(unitpartin) ddin(1)
          itime0=ddin(1)
        case default
          print *,'unknown format ',outfmt
          error=.true.
          return
        end select
      endif
      if((ibdate_arch /= ibdate).or.(ibtime_arch /= ibtime)) then
        print *,'restart > ibdate or itime non matching'
        print *,ibdate,ibdate_arch
        print *,ibtime,ibtime_arch
!	error=.true.
!	return
      endif
      select case (outfmt)
      case (100,101,102)
        allocate (xyz(3,nbuf),itra(nbuf))
        jseg=numpart/nbuf
        i1=1 ; i2=nbuf ; if=nbuf
        do j=1, jseg
          read(unitpartin)  (xyz(1:ir,i),itra(i),i=1,if)
          xtra1(i1:i2)=(xyz(1,1:if)-xlon0)/dx
          ytra1(i1:i2)=(xyz(2,1:if)-ylat0)/dy
          ztra1(i1:i2)= xyz(3,1:if)
          itra1(i1:i2)=itra(  1:if)
          i1=i1+if ; i2=i2+if
        enddo
        if(if*jseg<numpart) then
          i2=numpart ; if=i2-i1+1
          read(unitpartin) (xyz(1:ir,i),itra(i),i=1,if)
          xtra1(i1:i2)=(xyz(1,1:if)-xlon0)/dx
          ytra1(i1:i2)=(xyz(2,1:if)-ylat0)/dy
          ztra1(i1:i2)= xyz(3,1:if)
          itra1(i1:i2)=itra(  1:if)
        endif
      case (103)
        allocate (xyz(5,nbuf),itra(nbuf))
        allocate (qtra1(maxpart))
        jseg=numpart/nbuf
        i1=1 ; i2=nbuf ; if=nbuf
        do j=1, jseg
          read(unitpartin)  (xyz(1:ir,i),itra(i),i=1,if)
          xtra1(i1:i2)=(xyz(1,1:if)-xlon0)/dx
          ytra1(i1:i2)=(xyz(2,1:if)-ylat0)/dy
          ztra1(i1:i2)= xyz(3,1:if)
          qtra1(i1:i2)  = xyz(5,1:if)
          itra1(i1:i2)=itra(  1:if)
          i1=i1+if ; i2=i2+if
        enddo
        if(if*jseg<numpart) then
          i2=numpart ; if=i2-i1+1
          read(unitpartin) (xyz(1:ir,i),itra(i),i=1,if)
          xtra1(i1:i2)=(xyz(1,1:if)-xlon0)/dx
          ytra1(i1:i2)=(xyz(2,1:if)-ylat0)/dy
          ztra1(i1:i2)= xyz(3,1:if)
          qtra1(i1:i2)  = xyz(5,1:if)
          itra1(i1:i2)=itra(  1:if)
        endif
      case (105)
        allocate(itra0(maxpart))
!       read initial positions
        open(unitpartout4,file=trim(path(2))//'sav_init', &
             form='unformatted',status='old')
        read(unitpartout4)xtra1(1:numpart)
        read(unitpartout4)ytra1(1:numpart)
        read(unitpartout4)ztra1(1:numpart)
        read(unitpartout4)itra0(1:numpart)
        itra1(1:numpart)=itra0(1:numpart)
        close(unitpartout4)
        allocate (xyz(4,nbuf),itra(nbuf),idx(nbuf))
        read(unitpartin) (xyz(1:4,i),idx(i),itra(i),i=1,nbuf)
        do i=1,nbuf
          j=idx(i)
          xtra1(j)=(xyz(1,i)-xlon0)/dx
          ytra1(j)=(xyz(2,i)-ylat0)/dy
          ztra1(j)=xyz(3,i)
          itra1(j)=itime0
        enddo
      end select
      print *,'restart > completed'
      close(unitpartin)
      deallocate(xyz,itra,idx)
      return
      end
!
!=====|==1=========2=========3=========4=========5=========6=========7==
!
!$Log: 
