!$Id:
!
!=======================================================================
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ FLEXPART @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!=====|==1=========2=========3=========4=========5=========6=========7==
!
      subroutine savsav(itime)
!                          i
!*******************************************************************************
!                                                                              *
!     Dump all particle positions to save a state for restart                  *
!     Dump is first done to a temporary file and then moved to replace
!     the true save file replacing existing one.
!     This is to avoid failure to restart if NFS error occurs during
!     dump leaving the file incomplete
!                                                                              *
!     Author: B. Legras                                                        *
!                                                                              *
!     26 January 2004
!     redone : 2 September 2012 as a raw format output, no buffering 
!     and no transformation                                                         *
!                                                                              *
!*******************************************************************************
!                                                                              *
! Variables:                                                                   *
!                                                                              *
!*******************************************************************************

      use commons
      implicit none

      integer, intent(in):: itime
      integer i1,i2,j,jseg,outfmt,lhead
      integer ihour,jjjjmmdd,ihmmss      
      integer system

! Output all particles in raw format  
!*************************************

      outfmt=110     ! Output format
      lhead =6       ! Header length (# of lines)
      open(saveunit_tmp,file=trim(path(2))//'savpos_tmp', &
         form='unformatted')
      write(saveunit_tmp) lhead,outfmt
      write(saveunit_tmp) numpart, release_plan
      write(saveunit_tmp) ibdate,ibtime
      call caldate(bdate,jjjjmmdd,ihmmss)
      write(saveunit_tmp) jjjjmmdd,ihmmss
      write(saveunit_tmp) itime
      write(saveunit_tmp) allocated(itra0),allocated(ttra1),allocated(qtra1)
      write(saveunit_tmp) xtra1(1:numpart)
      write(saveunit_tmp) ytra1(1:numpart)
      write(saveunit_tmp) ztra1(1:numpart)
      write(saveunit_tmp) itra1(1:numpart)
      if (allocated(itra0)) write(saveunit_tmp) itra0(1:numpart)
      if (allocated(ttra1)) write(saveunit_tmp) ttra1(1:numpart)
      if (allocated(qtra1)) write(saveunit_tmp) qtra1(1:numpart)
      close(saveunit_tmp)

! Moves the file to its true name after successful write

      j=system('mv -f '//trim(path(2))//'savpos_tmp'//' '    &
                         //trim(path(2))//'savpos')
!     if (system('mv -f '//trim(path(2))//'savpos_tmp'//' '    &
!                        //trim(path(2))//'savpos')) then
         print *, 'checkpoint at t =',itime

      return
      end
!
!=====|==1=========2=========3=========4=========5=========6=========7==
!
!$Log:
