!$Id: openoutput.f,v 1.1.1.1 2001/10/03 17:53:13 legras Exp $
!
!=======================================================================
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ FLEXPART @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!=====|==1=========2=========3=========4=========5=========6=========7==
!
      subroutine openoutput(lunit1,lunit2,file1,file2,error)
C                             i      i      i     i     o
********************************************************************************
*                                                                              *
*   This routine opens the grid output file and computes the volume of each    *
*   grid cell.                                                                 *
*                                                                              *
*                                                                              *
*     Author: A. Stohl                                                         *
*                                                                              *
*     24 May 1995                                                              *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'
      
      integer jjjjmmdd,ihmmss,i,ix,jy,kz,j,lunit1,lunit2,iix,jjy,ixp,jyp
      integer i1,j1
      real xlon,ylat,xp1,yp1,xp2,yp2,xl,yl,ddx,ddy,rddx,rddy,p1,p2,p3,p4
      real gridarea,ylatp,ylatm,hzone,cosfact,cosfactm,cosfactp,pih,oroh
      parameter(pih=pi/180.)
      character file1*9,file2*13

      logical error


C Determine average height of model topography in output grid cells
*******************************************************************

      do 20 jjy=0,numygrid-1
        do 20 iix=0,numxgrid-1
          oroh=0.
          do 22 j1=1,10
            ylat=outlat0+(float(jjy)+float(j1)/10.-0.05)*dyout
            yl=(ylat-ylat0)/dy
            jy=int(yl)
            jyp=jy+1
            ddy=yl-float(jy)
            rddy=1.-ddy
            do 22 i1=1,10
              xlon=outlon0+(float(iix)+float(i1)/10.-0.05)*dxout
              xl=(xlon-xlon0)/dx
              ix=int(xl)
              ixp=ix+1
              ddx=xl-float(ix)
              rddx=1.-ddx
              p1=rddx*rddy
              p2=ddx*rddy
              p3=rddx*ddy
              p4=ddx*ddy
22            oroh=oroh+p1*oro(ix ,jy)
     +                + p2*oro(ixp,jy)
     +                + p3*oro(ix ,jyp)
     +                + p4*oro(ixp,jyp)
          oroout(iix,jjy)=oroh/100.
20        continue


C Open output file for grid
***************************

      open(lunit1,file=path(2)(1:len(2))//file1,
     +form='unformatted',err=998)

      write(lunit1) ibdate,ibtime,'FLEXPART V4.0'
      write(lunit1) outlon0,outlat0,numxgrid,numygrid,
     +dxout,dyout

      write(lunit1) numzgrid,(outheight(i),i=1,numzgrid)

      call caldate(bdate,jjjjmmdd,ihmmss)
      write(lunit1) jjjjmmdd,ihmmss
      write(lunit1) 3*nspec
      do 12 i=1,nspec
        write(lunit1) 1,'WD_'//species(i)(1:7)
        write(lunit1) 1,'DD_'//species(i)(1:7)
12      write(lunit1) numzgrid,species(i)
      write(lunit1) numpoint
      do 13 i=1,numpoint
        write(lunit1) ireleasestart(i),ireleaseend(i)
        xp1=xpoint1(i)*dx+xlon0
        yp1=ypoint1(i)*dy+ylat0
        xp2=xpoint2(i)*dx+xlon0
        yp2=ypoint2(i)*dy+ylat0
        write(lunit1) xp1,yp1,xp2,yp2,zpoint1(i),zpoint2(i)
        write(lunit1) npart(i),1
        write(lunit1) compoint(i)
        do 13 j=1,nspec
          write(lunit1) xmass(i,j)
          write(lunit1) xmass(i,j)
13        write(lunit1) xmass(i,j)
      write(lunit1) method,lsubgrid,lconvection
      write(lunit1) nageclass,(lage(i),i=1,nageclass)


C Write topography to output file
*********************************

      do 30 ix=0,numxgrid-1
30      write(lunit1) (oroout(ix,jy),jy=0,numygrid-1)


C Do the rest only for the gridded output files, not for the particle dump files
********************************************************************************

      if (lunit2.le.0) return

C Compute surface area and volume of each grid cell: area, volume,
C and the areas of the northward and eastward facing surfaces: areae, arean
***************************************************************************

      do 10 jy=0,numygrid-1
        ylat=outlat0+(float(jy)+0.5)*dyout
        ylatp=ylat+0.5*dyout
        ylatm=ylat-0.5*dyout
        if ((ylatm.lt.0).and.(ylatp.gt.0.)) then
          hzone=dyout*r_earth*pih
        else
          cosfact=cos(ylat*pih)*r_earth
          cosfactp=cos(ylatp*pih)*r_earth
          cosfactm=cos(ylatm*pih)*r_earth
          if (cosfactp.lt.cosfactm) then
            hzone=sqrt(r_earth**2-cosfactp**2)-
     +      sqrt(r_earth**2-cosfactm**2)
          else
            hzone=sqrt(r_earth**2-cosfactm**2)-
     +      sqrt(r_earth**2-cosfactp**2)
          endif
        endif
        gridarea=2.*pi*r_earth*hzone*dxout/360.

        do 10 ix=0,numxgrid-1
          area(ix,jy)=gridarea
          volume(ix,jy,1)=area(ix,jy)*outheight(1)
          areae(ix,jy,1)=dyout*r_earth*pih*outheight(1)
          arean(ix,jy,1)=cos(ylat*pih)*dxout*r_earth*pih*outheight(1)
          do 10 kz=2,numzgrid
            areae(ix,jy,kz)=dyout*r_earth*pih*
     +      (outheight(kz)-outheight(kz-1))
            arean(ix,jy,kz)=cos(ylat*pih)*dxout*r_earth*pih*
     +      (outheight(kz)-outheight(kz-1))
10          volume(ix,jy,kz)=area(ix,jy)*(outheight(kz)-outheight(kz-1))
 

C Open output file for receptor points
**************************************

      open(lunit2,file=path(2)(1:len(2))//file2,
     +form='unformatted',err=997)
      write(lunit2) (receptorname(j),j=1,numreceptor)
      write(lunit2) (xreceptor(j)*dx+xlon0,
     +yreceptor(j)*dy+ylat0,j=1,numreceptor)


      return


998   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE         #### '
      write(*,*) ' #### '//path(2)(1:len(2))//'grid'//' #### '
      write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
      write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
      write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
      error=.true.
      return

997   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE         #### '
      write(*,*) ' #### '//path(2)(1:len(2))//'receptor'//' #### '
      write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
      write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
      write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
      error=.true.
      return

      end
!
!=====|==1=========2=========3=========4=========5=========6=========7==
!
!$Log: openoutput.f,v $
!Revision 1.1.1.1  2001/10/03 17:53:13  legras
!FLEXPART 4.0 - original version
!
!
