!$Id: openoutputpart.f,v 1.1 2002/02/25 13:04:52 legras Exp $
!
!=======================================================================
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ FLEXPART @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!=====|==1=========2=========3=========4=========5=========6=========7==
!
      subroutine openoutputpart(lunit,file,error)
!                             i      i      i     i     o
!*******************************************************************************
!                                                                              *
!   This routine opens the output file for the particles                       *
!   grid cell.                                                                 *
!                                                                              *
!                                                                              *
!     Author: B. Legras                                                        *     
!                                                                              *
!     5 October 2001: 1st minimal version                                      *
!                                                                              *
!*******************************************************************************
!                                                                              *
! Variables:                                                                   *
!                                                                              *
!*******************************************************************************

      include 'includepar'
      include 'includecom'
      
      integer jjjjmmdd,ihmmss,i,ix,jy,kz,j,lunit,iix,jjy,ixp,jyp
      integer i1,j1
      real xlon,ylat,xp1,yp1,xp2,yp2,xl,yl,ddx,ddy,rddx,rddy,p1,p2,p3,p4
      real gridarea,ylatp,ylatm,hzone,cosfact,cosfactm,cosfactp,pih,oroh
      parameter(pih=pi/180.)
      character file*24

      logical error


! Open output file for grid
!**************************

      open(lunit,file=trim(path(2))//file,form='unformatted',err=998)

      write(lunit) ibdate,ibtime,'FLEXPART V4.0'
      write(lunit) 'PURE TRACER RUN'
      call caldate(bdate,jjjjmmdd,ihmmss)
      write(lunit) jjjjmmdd,ihmmss

! info about release locations      
      write(lunit) numpoint  ! number of release boxes
      do i=1,numpoint
        write(lunit) ireleasestart(i),ireleaseend(i)
        xp1=xpoint1(i)*dx+xlon0
        yp1=ypoint1(i)*dy+ylat0
        xp2=xpoint2(i)*dx+xlon0
        yp2=ypoint2(i)*dy+ylat0
        write(lunit) xp1,yp1,xp2,yp2,zpoint1(i),zpoint2(i)
        write(lunit) npart(i),1
        write(lunit) compoint(i)
!        do j=1,nspec
!          write(lunit1) xmass(i,j)
!          write(lunit1) xmass(i,j)
!          write(lunit1) xmass(i,j)
!        end do
      end do 
!      write(lunit1) method,lsubgrid,lconvection
!      write(lunit1) nageclass,(lage(i),i=1,nageclass)

      return

998   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE         #### '
      write(*,*) ' #### '//trim(path(2))//'particles'//'         #### '
      write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
      write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
      write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
      error=.true.
      return

      end
!
!=====|==1=========2=========3=========4=========5=========6=========7==
!
!$Log: openoutputpart.f,v $
!Revision 1.1  2002/02/25 13:04:52  legras
!Adds this routine to write simplified heading on the file containing
!particle positions.
!
!
!
