subroutine ortho(itime) 

!*******************************************************************************
!   	 Fixes perturbations used in the calculation of lyapunov charateristic *
!	 exponents							       *     
!	 Ignacio PISSO April 2004                                              *
! 	 						                       *
!*******************************************************************************
!                                                                              *
! Variables:                                                                   *
!                                                                              *
!*******************************************************************************

 use commons
 
 integer i,j,j1,k,m
 integer, intent (in) :: itime
 real, dimension(7,4) ::  p
 real, dimension(3,4) ::  h, b !perturbations respect to the particle before and after gram
 real, dimension(3,4) ::  c
 real, dimension(3) ::  lambdaa_loc,lambdab_loc
 !test-----
 real   mass_triad_f1, mass_triad_f2, mass_triad_b(maxlyap)
 common /mass/ mass_triad_b
 !---------
 
 j1 = numpart_np 
 do i=1,numpart_np 			!main loop 
 
    call grid2cart(p(1,1),p(1,2),p(1,3),xtra1(i),ytra1(i))
    p(1,4) = ztra1(i)
    do j=1,6  
       call grid2cart(p(j+1,1),p(j+1,2),p(j+1,3),xtra1(j1+j),ytra1(j1+j))
       p(j+1,4)= ztra1(j1+j)
    enddo
     
    do j=1,3
       c(j,:)=p(1,:) ! expand central particle
    enddo

!1st triad
!*********
 
    h = p(2:4,:) - c
    call gramlam(h,b,lambdaa_loc)
    p(2:4,:) = c + b
    lambdaa(:,i) = lambdaa(:,i) + lambdaa_loc
    
    !---test
    mass_triad_f1 = exp(-ztra1(i)+lambdaa_loc(1)+lambdaa_loc(2)+lambdaa_loc(3))
    !-------    
    
!2nd triad
!*********
  
    h = p(5:7,:) - c
    call gramlam(h,b,lambdab_loc)
    p(5:7,:) = c + b
    lambdab(:,i) = lambdab(:,i) + lambdab_loc

    !---test
    mass_triad_f2 = exp(-ztra1(i)+lambdab_loc(1)+lambdab_loc(2)+lambdab_loc(3))
    write(*,'(a,i10,i5,2G14.5)') ' ortho> ', itime, i, &
       mass_triad_f1/mass_triad_b(i),mass_triad_f2/mass_triad_b(i)
    !-------

!New perturbations in grid coordinates
!*************************************

    do j=1,6
       call sphere(p(j+1,:))
       call cart2grid(xtra1(j1+j),ytra1(j1+j),p(j+1,1),p(j+1,2),p(j+1,3))
       ztra1(j1+j) = p(j+1,4)                       !&&&&&& was error there ztra1(j1+1)
    enddo
   
    j1=j1+6 
 enddo  !end main loop

 return
 
 contains
 
!*************************************************************************
!Normalisation 4D (normal)
!*************************************************************************  
 
 subroutine sphere(v)
 real, dimension(4) :: v
 real arrow
 arrow=1/sqrt(v(1)**2 + v(2)**2 + v(3)**2)
 v(1) = v(1)*arrow
 v(2) = v(2)*arrow
 v(3) = v(3)*arrow
 end subroutine sphere
 
 end subroutine ortho
