!$Id: 
!
!=======================================================================
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ FLEXPART @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!=====|==1=========2=========3=========4=========5=========6=========7==
!
      subroutine readageclasses(error)
!                                 o
!*******************************************************************************
!                                                                              *
!     This routine reads the age classes to be used for the current model run. *
!                                                                              *
!     Author: A. Stohl                                                         *
!                                                                              *
!     20 March 2000                                                            *
!                                                                              *
!*******************************************************************************
!                                                                              *
! Variables:                                                                   *
!                                                                              *
! Constants:                                                                   *
!                                                                              *
!*******************************************************************************

      use commons
      implicit none

      integer i
      logical error


! If age spectra calculation is switched off, set number of age classes
! to 1 and maximum age to a large number
!**********************************************************************

      if (lagespectra.ne.1) then
        nageclass=1
        lage(nageclass)=999999999
        return
      endif


! If age spectra claculation is switched on,
! open the AGECLASSSES file and read user options
!************************************************

      error=.false.

      open(unitageclasses,file=path(1)(1:len(1))//'AGECLASSES', &
           status='old',err=999)

      do i=1,13
        read(unitageclasses,*)
      enddo
      read(unitageclasses,*) nageclass
      

      if (nageclass.gt.maxageclass) then
        write(*,*) ' #### FLEXPART MODEL ERROR! NUMBER OF AGE     #### ' 
        write(*,*) ' #### CLASSES GREATER THAN MAXIMUM ALLOWED.   #### '
        write(*,*) ' #### CHANGE SETTINGS IN FILE AGECLASSES OR   #### '
        write(*,*) ' #### RECOMPILE WITH LARGER MAXAGECLASS IN    #### '
        write(*,*) ' #### FILE INCLUDEPAR.                        #### '
        error=.true.
        return
      endif

      read(unitageclasses,*) lage(1)
      if (lage(1).le.0) then
        write(*,*) ' #### FLEXPART MODEL ERROR! AGE OF FIRST      #### ' 
        write(*,*) ' #### CLASS MUST BE GREATER THAN ZERO. CHANGE #### ' 
        write(*,*) ' #### SETTINGS IN FILE AGECLASSES.            #### ' 
        error=.true.
      endif
 
      do i=2,nageclass
        read(unitageclasses,*) lage(i)
        if (lage(i).le.lage(i-1)) then
          write(*,*) ' #### FLEXPART MODEL ERROR! AGE CLASSES     #### ' 
          write(*,*) ' #### MUST BE GIVEN IN TEMPORAL ORDER.      #### ' 
          write(*,*) ' #### CHANGE SETTINGS IN FILE AGECLASSES.   #### '
          error=.true.
        endif
      enddo

      return    

999   write(*,*) ' #### FLEXPART MODEL ERROR! FILE "AGECLASSES" #### ' 
      write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
      write(*,*) ' #### xxx/flexpart/options                    #### '
      error=.true.

      return
      end
!
!=====|==1=========2=========3=========4=========5=========6=========7==
!
!$Log: 
