!$Id: readreceptors.f,v 1.1.1.1 2001/10/03 17:53:13 legras Exp $
!
!=======================================================================
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ FLEXPART @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!=====|==1=========2=========3=========4=========5=========6=========7==
!
      subroutine readreceptors(error)
C                                o
********************************************************************************
*                                                                              *
*     This routine reads the user specifications for the receptor points.      *
*                                                                              *
*     Author: A. Stohl                                                         *
*                                                                              *
*     1 August 1996                                                            *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* receptorarea(maxreceptor)  area of dx*dy at location of receptor             *
* receptorname(maxreceptor)  names of receptors                                *
* xreceptor,yreceptor  coordinates of receptor points                          *
*                                                                              *
* Constants:                                                                   *
* unitreceptor         unit connected to file RECEPTORS                        *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer i,j
      real x,y,xm,ym
      character*16 receptor
      logical error


C Open the RECEPTORS file and read output grid specifications
*************************************************************

      error=.false.

      open(unitreceptor,file=path(1)(1:len(1))//'RECEPTORS',
     +status='old',err=999)

      do 10 i=1,5
10      read(unitreceptor,*)


C Read the names and coordinates of the receptors
*************************************************

      j=0
100     j=j+1
        read(unitreceptor,*,end=99)
        read(unitreceptor,*,end=99)
        read(unitreceptor,*,end=99)
        read(unitreceptor,'(4x,a16)',end=99) receptor
        read(unitreceptor,*,end=99)
        read(unitreceptor,*,end=99)
        read(unitreceptor,*,end=99)
        read(unitreceptor,'(4x,f11.4)',end=99) x
        read(unitreceptor,*,end=99)
        read(unitreceptor,*,end=99)
        read(unitreceptor,*,end=99)
        read(unitreceptor,'(4x,f11.4)',end=99) y
        if ((x.eq.0.).and.(y.eq.0.).and.
     +  (receptor.eq.'                ')) then
          j=j-1
          goto 100
        endif
        if (j.gt.maxreceptor) then
        write(*,*) ' #### FLEXPART MODEL ERROR! TOO MANY RECEPTOR #### ' 
        write(*,*) ' #### POINTS ARE GIVEN.                       #### ' 
        write(*,*) ' #### MAXIMUM NUMBER IS ',maxreceptor,'       #### ' 
        write(*,*) ' #### PLEASE MAKE CHANGES IN FILE RECEPTORS   #### ' 
        endif
        receptorname(j)=receptor
        xreceptor(j)=(x-xlon0)/dx       ! transform to grid coordinates
        yreceptor(j)=(y-ylat0)/dy
        xm=r_earth*cos(y*pi/180.)*dx/180.*pi
        ym=r_earth*dy/180.*pi
        receptorarea(j)=xm*ym
        goto 100

99    numreceptor=j-1
      close(unitreceptor)
      return


999   write(*,*) ' #### FLEXPART MODEL ERROR! FILE "RECEPTORS"  #### '
      write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
      write(*,*) ' #### xxx/flexpart/options                    #### '
      error=.true.
 
      return
      end
!
!=====|==1=========2=========3=========4=========5=========6=========7==
!
!$Log: readreceptors.f,v $
!Revision 1.1.1.1  2001/10/03 17:53:13  legras
!FLEXPART 4.0 - original version
!
!
